                             
' /////////////////////////////////////////////////////////////////////////////
' Donkey Kong Remake
' AUTHOR: Steve Waddicor
'//////////////////////////////////////////////////////////////////////////////

'If you don't have the sound driver, comment out for following lines that starts with {SOUND}
OBJ
{SOUND} sfx   : "ns_sound_drv_052_22khz_16bit.spin"
PRI SoundStart
{SOUND} sfx.Start(7)
PRI SoundCrash
{SOUND} sfx.PlaySoundFM(1, sfx#SHAPE_NOISE, sfx#NOTE_C5, sfx#SAMPLE_RATE/16,  255, $3579_ADEF)'$2525ba6f )
{SOUND} sfx.PlaySoundFM(2, sfx#SHAPE_NOISE, sfx#NOTE_Db2, sfx#SAMPLE_RATE/20, 255, $3579_ADEF)'$43f98adf )
{SOUND} sfx.PlaySoundFM(3, sfx#SHAPE_NOISE, sfx#NOTE_Fs5, sfx#SAMPLE_RATE/8,  255, $3579_ADEF)'$12b4321f )
{SOUND} sfx.PlaySoundFM(4, sfx#SHAPE_NOISE, sfx#NOTE_E6, sfx#SAMPLE_RATE/23,  255, $3579_ADEF)'$136bab7f )
{SOUND} sfx.PlaySoundFM(5, sfx#SHAPE_NOISE, sfx#NOTE_Ab5, sfx#SAMPLE_RATE/10, 255, $3579_ADEF)' $38ed96f )

OBJ

  tv    : "sw_dk_tv_drv_022.spin"
  gfx   : "sw_dkong_gfx_008.spin"
  rend  : "sw_dk_gfx_renderer_014.spin"

CON
    _clkmode = xtal1 + pll8x
    _xinfreq = 10_000_000 + 0000
    _stack = 300
    '1 cog for game logic (this one)
    '1 cog for TV driver
    '1 cog for sound
    '=5 cogs for rendering
    cogs = 5

CON
    SPRITE_FLAGS                =3
    SPRITE_TILE                 =2
    SPRITE_XPOS                 =1
    SPRITE_YPOS                 =0
    SPRITE_FLAGS_AND_TILE_WORD  =1 
    SPRITE_LOCATION_WORD        =0 
    SPRITE_INVISIBLE            =%100
    SPRITE_FLIPPED              =%010
    SPRITE_MIRRORED             =%001
    
CON
    NUMBER_OF_BARRELS           = 10
    NUMBER_OF_LADDERS           = 2
    NUMBER_OF_SPRINGS           = 2
    NUMBER_OF_PIES              = 5
    NUMBER_OF_HAMMERS           = 2

CON
    WORKING_MAP = 0

CON
    #0
    'states where user input accepted
    MARIO_FACING_LEFT 
    MARIO_FACING_RIGHT
    MARIO_WALK_LEFT   
    MARIO_WALK_RIGHT  
    MARIO_CLIMB_UP    
    MARIO_CLIMB_DOWN  
    'no user input accepted
    MARIO_JUMP_LEFT           
    MARIO_JUMP_RIGHT          
    MARIO_JUMP_UP_FACING_LEFT  
    MARIO_JUMP_UP_FACING_RIGHT
    MARIO_LANDING_LEFT        
    MARIO_LANDING_RIGHT
    MARIO_DEAD_INIT     

CON
    #0
    MARIO_NOT_ON_LIFT
    MARIO_LIFT_UP
    MARIO_LIFT_DOWN

CON
    #0
    GAME_HOW_HIGH_INIT
    GAME_HOW_HIGH     
    GAME_LEVEL_1_INIT 
    GAME_LEVEL_2_INIT 
    GAME_LEVEL_3_INIT 
    GAME_LEVEL_4_INIT 
    GAME_LEVEL_1      
    GAME_LEVEL_2      
    GAME_LEVEL_3      
    GAME_LEVEL_4
    GAME_CLIMB_INIT
    GAME_CLIMB_SCENE
    GAME_LEVEL_12_END_SCENE_INIT
    GAME_LEVEL_12_END_SCENE
    GAME_LEVEL_3_END_SCENE_INIT
    GAME_LEVEL_3_END_SCENE
    GAME_LEVEL_123_FOLLOW_ON
    GAME_LEVEL_4_END_SCENE_INIT
    GAME_LEVEL_4_END_SCENE

CON

    KONG_LEVEL_START_POSE_INIT  = 0
    KONG_LEVEL_START_POSE       = 1
    ' Barrel rolling states i.e. Level 1
    KONG_BR_LEFT                = 2
    KONG_BR_CENTER_1            = 3
    KONG_BR_RIGHT               = 4
    KONG_BR_CENTER_2            = 5
    KONG_BR_GROWL               = 6
    KONG_BR_LEFT_INIT           = 7
    KONG_BR_CENTER_1_INIT       = 8
    KONG_BR_RIGHT_INIT          = 9
    KONG_BR_CENTER_2_INIT       = 10
    KONG_BR_GROWL_INIT          = 11
    ' Normal states i.e. Levels 2-4
    KONG_NORMAL_INIT            = 12
    KONG_NORMAL                 = 13    

CON
    #0
    BARREL_STILL               
    BARREL_ROLLING_RIGHT       
    BARREL_ROLLING_LEFT        
    BARREL_FALLING_RIGHT       
    BARREL_FALLING_LEFT        
    BARREL_BOUNCING_RIGHT      
    BARREL_BOUNCING_LEFT       
    BARREL_ON_LADDER_RIGHT     
    BARREL_ON_LADDER_LEFT      
    BARREL_FALLING_DOWN        
    BARREL_FALLING_ACROSS      
    FIREBALL_JUMP_LEFT_INIT    
    FIREBALL_JUMP_LEFT         
    FIREBALL_JUMP_RIGHT_INIT   
    FIREBALL_JUMP_RIGHT        
    FIREBALL_BOUNCE_LEFT_INIT  
    FIREBALL_BOUNCE_RIGHT_INIT 
    FIREBALL_BOUNCE_LEFT       
    FIREBALL_BOUNCE_RIGHT      
    FIREBALL_MOVE_RIGHT        
    FIREBALL_UP_LADDER         
    FIREBALL_DOWN_LADDER       
    FIREBALL_WAITING           

CON
    #0
    DRUM_UNLIT       
    DRUM_LIT         
    DRUM_FLARING     
    DRUM_LIT_INIT    
    DRUM_FLARING_INIT
    DRUM_LIT_LEVEL3

CON
    PAULINE_STILL_INIT          = 0
    PAULINE_STILL               = 1
    PAULINE_SCREAM_INIT         = 2
    PAULINE_SCREAM              = 3

CON
    LADDER_UP                   = 0
    LADDER_GOING_DOWN           = 1
    LADDER_DOWN                 = 2
    LADDER_GOING_UP             = 3

CON
    #0
    CONVEYOR_RIGHT
    CONVEYOR_LEFT

CON
    #0
    BONUS_NONE
    BONUS_BARREL_BUSTED_INIT
    BONUS_BARREL_BUSTED

VAR
    ' Renderer parameter block
    ' Initializing data is in the DAT block at the end of this file.
    ' This is copied in to this variable space with a longmove
    ' so it can be altered easily (without remembering to use @ all the time).
    ' Each renderer then copies these values to it's own cog_memory cache
    ' when it's got a little spare time, several times per frame
    ' so these values can be altered on the fly.                                                       
    long    rend_cog_number        'each cog gets a different number, starting with zero     write-only
    long    rend_scanline_req_adr  'a pointer to the request to put a line in the scan buffer   write-only
    long    rend_map               'pointer to screen (bytes)                                write-only
    long    rend_tile_table_ptr    'pointer to tile definitions (words)                      write-only
    long    rend_tile_palette_ptr
    long    rend_sprite_table_ptr  'pointer to tile definitions (longs)                      write-only
    long    rend_hotspot_table_ptr  
    long    rend_sprite_palette_ptr 'pointer to colors (longs)                               write-only               
    long    rend_ht                'horizontal tiles                                         write-only
    long    rend_vt                'vertical tiles                                           write-only
    long    rend_scanline_buffer_adr 'hub memory where renderer puts scanline when requested write-only
    long    rend_cog_count         'total number of cogs                                     write-only
    long    rend_debug_map_ptr
    long    rend_sprites[NUMBER_OF_SPRITES]       '%_____ifm_nnnnnnnn_xxxxxxxx_yyyyyyyy    (invisible, flipped, mirrored)
    'End of redderer parameter block

VAR
    ' TV parameter block
    long    tv_scanline_request
    long    tv_scanline_buffer
    long    tv_status
    ' End of TV parameter block  

VAR
    long  startkey
    long  debug
    word  debug_map[32*28]


VAR
    byte    game_state
    byte    mario_state
    byte    mario_lift_state
    byte    kong_state
    byte    kong_conveyor_state
    byte    middle_left_conveyor_state
    byte    middle_right_conveyor_state
    byte    bottom_conveyor_state
    byte    drum_state
    byte    pauline_state
    byte    bonus_state
    byte    barrel_state[NUMBER_OF_BARRELS]
    byte    ladder_state[NUMBER_OF_LADDERS]
    byte    action_hammer
    byte    bonus_freeze

    long    gp
    long    game_state_count
    long    game_level
    long    game_score
    long    timer
    long    timer_state_count
    long    mario_state_count
    long    hammer_state_count
    long    kong_state_count
    long    kong_pose_source
    long    kong_barrel_releases
    long    kong_holding_barrel
    long    kong_real_x
    long    kong_real_y
    long    kong_conveyor_state_count
    long    conveyor_state_count
    long    pie_state_count
    long    barrel_state_count[NUMBER_OF_BARRELS]
    long    barrel_anim[NUMBER_OF_BARRELS]
    long    fireball_real_y[NUMBER_OF_BARRELS]
    long    drum_state_count
    long    drum_flicker_count
    long    pauline_state_count
    long    ladder_state_count[NUMBER_OF_LADDERS]
    long    lift_state_count
    long    bonus_state_count
    long    spring_state_count[2]
    long    spring_real_x[2]
    long    rivet_state_count
    long    remove_rivet_x
    long    remove_rivet_y
    long    rivets_left
    long    sound_state_count
    long    frame
    long    rnd

CON
    NUMBER_OF_SPRITES           = 35

' Level 1 = Barrels
' Level 2 = Springs
' Level 3 = Conveyors
' Level 4 = Rivets

'    Level 1           Level 2           Level 3           Level 4                  
'  0 Pauline           Pauline           Pauline           Pauline                    
'  1 Pauline           Pauline           Pauline           Pauline
'  2 Kong              Kong              Kong              Kong                     
'  3 Kong              Kong              Kong              Kong                     
'  4 Kong              Kong              Kong              Kong                     
'  5 Kong              Kong              Kong              Kong                     
'  6 Kong              Kong              Kong              Kong                     
'  7 Kong              Kong              Kong              Kong                     
'  8 Kong                                Ladder            Kong Stars                         
'  9 Kong                                Ladder                                     
' 10 Mario             Mario             Mario             Mario                    
' 11 Barrel/Fireball   Barrel/Fireball   Barrel/Fireball   Barrel/Fireball          
' 12 Barrel/Fireball   Barrel/Fireball   Barrel/Fireball   Barrel/Fireball          
' 13 Barrel/Fireball   Spring            Barrel/Fireball   Barrel/Fireball          
' 14 Barrel/Fireball   Spring            Barrel/Fireball   Barrel/Fireball          
' 15 Barrel/Fireball   Lift              Barrel/Fireball   Barrel/Fireball          
' 16 Barrel/Fireball   Lift              Pie                                        
' 17 Barrel/Fireball   Lift              Pie                                        
' 18 Barrel/Fireball   Lift              Pie                                        
' 19 Barrel/Fireball   Lift              Pie                                        
' 20 Barrel/Fireball   Lift              Pie                                        
' 21 Fixed-Barrel      Winch             Motor                                      
' 22 Fixed-Barrel      Winch             Motor                                      
' 23 Fixed-Barrel      Winch             Motor                                      
' 24 Fixed-Barrel      Winch             Motor                                      
' 25                                     Motor                                                        
' 26                                     Motor                                                        
' 27                   Umbrella          Umbrella          Umbrella                 
' 28                   Hat               Hat               Hat                      
' 29                   Handbag           Handbag           Handbag                  
' 30 Oil Drum                            Oil Drum                                   
' 31 Oil Drum Flame                      Oil Drum Flame                             
' 32 Hammer            Hammer            Hammer            Hammer                     
' 33 Hammer            Hammer            Hammer            Hammer                     
' 34 Bonus             Bonus             Bonus             Bonus                  
  
    'sprite indexes 
    PAULINE_SPRITES             = 0
    KONG_SPRITES                = 2                        
    LADDER_SPRITES              = 8
    KONGS_STAR_SPRITE           = 8                                      
    MARIO_SPRITE                = 10                
    MOVING_BARREL_SPRITES       = 11
    SPRING_SPRITES              = 13
    LIFT_SPRITES                = 15
    PIE_SPRITES                 = 16                    
    FIXED_BARREL_SPRITES        = 21
    WINCH_SPRITES               = 21
    MOTOR_SPRITES               = 21
    HEART_SPRITE                = 27
    COLLECTABLE_SPRITES         = 27
    OIL_DRUM_SPRITE             = 30
    OIL_DRUM_FLAME_SPRITE       = 31                    
    HAMMER_SPRITES              = 32            
    BONUS_SPRITE                = 34                   


PUB Main | i, time, game_counter, total_time, avg_time
    'Start renderers
'    long[@kong_center_barrel_template][0]:=$00_10_80_80
    rend_tile_table_ptr := gfx.tile_adr
    rend_sprite_table_ptr := gfx.sprite_adr
    rend_hotspot_table_ptr := gfx.sprite_hotspot_adr
    rend_sprite_palette_ptr := gfx.sprite_palette_adr
    rend_tile_palette_ptr := gfx.tile_palette_adr
    SelectMap(WORKING_MAP)
    rend_ht := 32
    rend_vt := 28
    rend_scanline_buffer_adr := @hub_scanline_buffer
    rend_scanline_req_adr := @scanline_req
    rend_cog_count := cogs
    repeat i from 0 to constant(NUMBER_OF_SPRITES-1)
        rend_sprites[i] := $04_00_00_00                 'make them all invisible by default


    rend_debug_map_ptr := 0
    repeat i from 0 to constant(cogs-1)
        rend_cog_number := i
        rend.start(@rend_cog_number)
        'Wait to allow this cog to get the cog number param from the block before changing it.
        repeat 1000
     
    tv_scanline_request := @scanline_req                
    tv_scanline_buffer := @hub_scanline_buffer          
    tv.start(@tv_scanline_request)
    
    DebugInit(gfx.map_adr)
    rend_debug_map_ptr:=0

    hdmf1_state := HDMF__STATE_IDLE
    SoundStart

    game_state := GAME_CLIMB_INIT
'    game_state := GAME_HOW_HIGH_INIT
    'game_counter := 0
    game_level := 0
    game_score := 0
    time:=CNT
    rnd:=$439845f0

    'Main Game Loop
    repeat
        'TV will let up know when there is a vsync
        tv_status := 0
'        outa[1]:=2
        
        gp := NES_Read_Gamepad


        case game_state
            GAME_CLIMB_INIT:
                game_state_count := 0
                game_state := GAME_CLIMB_SCENE
                hdmf1_state := HDMF__STATE_START_SONG
                hdmf1_song_start_ptr := @_SONG_start
                hdmf1_flags := 0
            GAME_CLIMB_SCENE:
                SoundLogic
                ClimbScene
                SoundLogic
            GAME_HOW_HIGH_INIT:
                SpriteClear
                SelectMap(WORKING_MAP)
                ClearMap(0)
                DrawString(5,26,string("HOW HIGH CAN YOU GET ?"),4)
                repeat i from 0 to game_level//4
                    DrawKong(13,21-i*4)
                    DrawKongHeight(8,24-i*4,i)
                game_state := GAME_HOW_HIGH
                game_state_count := 220
                hdmf1_state := HDMF__STATE_START_SONG
                hdmf1_song_start_ptr := @_SONG_how_high
                hdmf1_flags := 0
            GAME_HOW_HIGH:
                SoundLogic
                game_state_count--
                if game_state_count == 0
                    game_state := GAME_LEVEL_1_INIT + game_level//4   
            GAME_LEVEL_1_INIT:
                InitLevelCommon
                InitLevel1
                hdmf1_state := HDMF__STATE_START_SONG
                hdmf1_song_start_ptr := @_SONG_background_music
                hdmf1_flags := HDMF__FLAG_LOOP_SONG
            GAME_LEVEL_2_INIT:
                InitLevelCommon
                InitLevel2
            GAME_LEVEL_3_INIT:
                InitLevelCommon
                InitLevel3
            GAME_LEVEL_4_INIT:
                InitLevelCommon
                InitLevel4
            GAME_LEVEL_1:
                SoundLogic 
                if BonusLogic
                    if !(rend_sprites.byte[SPRITE_FLAGS]&SPRITE_INVISIBLE)  'NEEDS FIXING!!!!!!!!!!!!!!!!!!!!!
                        MarioLogic
                    KongLogic
                    SoundLogic 
                    BarrelLogic
                    DrumLogic
                    PaulineLogic
            GAME_LEVEL_2:    
                SoundLogic 
                if BonusLogic
                    LiftLogic
                    if !(rend_sprites.byte[SPRITE_FLAGS]&SPRITE_INVISIBLE)
                        MarioLogic
                    KongLogic
                    SoundLogic 
                    BarrelLogic
                    SpringLogic
                    PaulineLogic
            GAME_LEVEL_3:    
                SoundLogic 
                if BonusLogic
                    ConveyorLogic
                    if !(rend_sprites.byte[SPRITE_FLAGS]&SPRITE_INVISIBLE)
                        MarioLogic
                    KongLogic
                    LadderLogic
                    PaulineLogic
                    SoundLogic 
                    BarrelLogic
                    DrumLogic
            GAME_LEVEL_4:    
                SoundLogic 
                if BonusLogic
                    if !(rend_sprites.byte[SPRITE_FLAGS]&SPRITE_INVISIBLE)
                        MarioLogic
                    KongLogic
                    PaulineLogic
                    SoundLogic 
                    BarrelLogic
                    RivetLogic
            GAME_LEVEL_12_END_SCENE_INIT:
                game_state_count:=0
                game_state:=GAME_LEVEL_12_END_SCENE
            GAME_LEVEL_12_END_SCENE:
                Level12EndScene
                             
            GAME_LEVEL_3_END_SCENE_INIT:
                game_state_count:=0
                game_state:=GAME_LEVEL_3_END_SCENE
            GAME_LEVEL_3_END_SCENE:
                Level3EndScene

            GAME_LEVEL_123_FOLLOW_ON:
                Level123FollowOn

            GAME_LEVEL_4_END_SCENE_INIT:
                game_state_count:=0
                game_state:=GAME_LEVEL_4_END_SCENE
            GAME_LEVEL_4_END_SCENE:
                Level4EndScene
                                 
        if gp & %00010000
            if startkey==0
                startkey:=1
                !debug
                if debug
                    rend_debug_map_ptr:=@debug_map'gfx.map_adr
                else
                    rend_debug_map_ptr:=0
        else
            startkey:=0
        DebugInit(@debug_map)

        total_time:=CNT-time
        'debugdec(@timetext,((cnt-time)/game_counter++))
        'debughex(@timetext,$89abcdef)
        'repeat 30000
        repeat until tv_status>0
        
PRI SpriteClear | i
    repeat i from 0 to NUMBER_OF_SPRITES
        rend_sprites[i]:= $04_00_10_00
    repeat i from 0 to constant(NUMBER_OF_BARRELS-1)
        barrel_state[i] := BARREL_STILL

PRI EndLevelSpriteClear | i
    repeat i from MOVING_BARREL_SPRITES to constant(MOVING_BARREL_SPRITES+NUMBER_OF_BARRELS-1)
        rend_sprites[i]:= $04_00_10_00
    repeat i from 0 to constant(NUMBER_OF_BARRELS-1)
        barrel_state[i] := BARREL_STILL
    rend_sprites[HAMMER_SPRITES]             := $04_00_10_00
    rend_sprites[constant(HAMMER_SPRITES+1)] := $04_00_10_00    
    word[rend_map][13] := gfx#TILE_SPACE
    word[rend_map][14] := gfx#TILE_SPACE
    word[rend_map][15] := gfx#TILE_SPACE
    word[rend_map][16] := gfx#TILE_SPACE
    word[rend_map][17] := gfx#TILE_SPACE

PRI InitLevelCommon
    SpriteClear
    pauline_state := PAULINE_SCREAM_INIT
    frame := constant(SPRITE_INVISIBLE<<8)
    kong_state := KONG_LEVEL_START_POSE_INIT
    hammer_state_count:=0
    timer_state_count:=128
    timer := 5000 + game_level//4*1000
    timer <#= 8000
    

CON
    
    DRAW_END_DRAWING            = 246
    DRAW_USE_TILE               = 247
    DRAW_VERTICALS              = 249
    DRAW_HORIZONTALS            = 251
    DRAW_PLATFORM_UPWARDS       = 252
    DRAW_PLATFORM_FLAT          = 253
    DRAW_PLATFORM_DOWNWARDS     = 254
    DRAW_RECTANGLE              = 255
    
PRI DrawFromData(p) | tilepos, i, j, start, end, tile, y, slope, x1, y1, x2, y2, opcode
    repeat while byte[p]<>DRAW_END_DRAWING
        opcode := byte[p++]
        case opcode
            DRAW_USE_TILE:
                tile:=byte[p++]
            DRAW_VERTICALS:
                repeat until byte[p]=>DRAW_END_DRAWING
                    tilepos:=(byte[p++]+2+(byte[p]<<5))<<1+gfx.map_adr
                    start:=byte[p++]
                    end:=byte[p++]
                    repeat i from start to end
                        byte[tilepos] := tile
                        tilepos+=64
            DRAW_HORIZONTALS:
                repeat until byte[p]=>DRAW_END_DRAWING
                    start:=byte[p++]
                    end:=byte[p++]
                    tilepos:=(start+2+(byte[p++]<<5))<<1 + gfx.map_adr
                    repeat i from start to end
                        byte[tilepos] := tile
                        tilepos+=2
            DRAW_RECTANGLE:
                x1:=byte[p++]
                y1:=byte[p++]
                x2:=byte[p++]
                y2:=byte[p++]
                repeat i from y1 to y2
                    repeat j from x1 to x2
                        tilepos:=(j+2+(i<<5))<<1 + gfx.map_adr
                        byte[tilepos] := byte[p]
                p++
            DRAW_PLATFORM_UPWARDS,DRAW_PLATFORM_FLAT,DRAW_PLATFORM_DOWNWARDS:
                start:=byte[p++]
                end:=byte[p++]
                y:=byte[p++]
                repeat i from start to end
                    DrawPlatformTile(start++,y)
                    if start//2==0
                        y+=opcode-DRAW_PLATFORM_FLAT
              
PRI InitLevel1 | i
    ' Barrels & Slopes
    ClearMap(0)
    DrawFromData(@level1def)
    DrawStatus
    DrawBonusBox
    kong_real_x := $3c
    kong_real_y := $33
    rend_sprites[MARIO_SPRITE]                     := $04_00_3c_d7
    rend_sprites[FIXED_BARREL_SPRITES  ]           := $00_17_14_23
    rend_sprites[constant(FIXED_BARREL_SPRITES+1)] := $00_17_14_32
    rend_sprites[constant(FIXED_BARREL_SPRITES+2)] := $00_17_1e_23
    rend_sprites[constant(FIXED_BARREL_SPRITES+3)] := $00_17_1e_32
    rend_sprites[HAMMER_SPRITES]                   := $00_1b_25_4b
    rend_sprites[constant(HAMMER_SPRITES+1)]       := $00_1b_bc_a7
    rend_sprites[OIL_DRUM_SPRITE]                  := $00_42_28_d8
    repeat i from 0 to constant(NUMBER_OF_BARRELS-1)
        barrel_state[i] := BARREL_STILL
    game_state := GAME_LEVEL_1

PRI InitLevel2 | i
    ' Springs
    ClearMap(0)
    DrawFromData(@level2def)
    DrawStatus
    DrawBonusBox
    kong_real_x := $3c
    kong_real_y := $37
    rend_sprites[MARIO_SPRITE]                          := $04_00_10_c7
    rend_sprites[LIFT_SPRITES  ]                        := $00_3F_38_64
    rend_sprites[constant(LIFT_SPRITES+1)]              := $00_3F_38_98 '+$34
    rend_sprites[constant(LIFT_SPRITES+2)]              := $00_3F_38_cc
    rend_sprites[constant(LIFT_SPRITES+3)]              := $00_3F_78_48
    rend_sprites[constant(LIFT_SPRITES+4)]              := $00_3F_78_7c
    rend_sprites[constant(LIFT_SPRITES+5)]              := $00_3F_78_b0
    rend_sprites[WINCH_SPRITES  ]                       := $00_40_38_38
    rend_sprites[constant(WINCH_SPRITES+1)]             := $02_40_38_cf
    rend_sprites[constant(WINCH_SPRITES+2)]             := $00_40_78_38
    rend_sprites[constant(WINCH_SPRITES+3)]             := $02_40_78_cf
    rend_sprites[COLLECTABLE_SPRITES  ]                 := $00_51_1c_67 'umbrella
    rend_sprites[constant(COLLECTABLE_SPRITES+1)]       := $00_4f_5c_af 'hat
    rend_sprites[constant(COLLECTABLE_SPRITES+2)]       := $00_50_e4_47 'handbag   
    rend_sprites[MOVING_BARREL_SPRITES  ]               := $00_39_58_68
    rend_sprites[constant(MOVING_BARREL_SPRITES+1)]     := $00_39_e4_48
    fireball_real_y[0]                   := $68
    fireball_real_y[1]                   := $48    
    barrel_state[0]                      := FIREBALL_BOUNCE_LEFT_INIT
    barrel_state[1]                      := FIREBALL_BOUNCE_RIGHT_INIT
    rend_sprites[SPRING_SPRITES]                        := $00_37_78_37
    rend_sprites[constant(SPRING_SPRITES+1)]            := $00_37_88_37
    spring_state_count[0]                :=0
    spring_state_count[1]                :=-100
    spring_real_x[0]                     :=0
    spring_real_x[1]                     :=0
    game_state := GAME_LEVEL_2

PRI InitLevel3 | i
    ' Conveyors
    ClearMap(7)
    DrawFromData(@level3def)
    DrawStatus
    DrawBonusBox
    kong_real_x := $40
    kong_real_y := $37
    rend_sprites[MARIO_SPRITE]           := $04_00_3c_d7
    rend_sprites[LADDER_SPRITES  ]       := $00_41_24_4f
    rend_sprites[constant(LADDER_SPRITES+1)]       := $00_41_dc_4f
    ladder_state[0] := LADDER_UP
    ladder_state[1] := LADDER_UP
    rnd := ?rnd
    ladder_state_count[0] := rnd&$ff
    rnd := ?rnd
    ladder_state_count[1] := rnd&$ff
    rend_sprites[MOTOR_SPRITES  ]            := $00_47_10_38
    rend_sprites[constant(MOTOR_SPRITES+1)]  := $01_47_e0_38
    rend_sprites[constant(MOTOR_SPRITES+2)]  := $01_47_6c_60
    rend_sprites[constant(MOTOR_SPRITES+3)]  := $00_47_84_60
    rend_sprites[constant(MOTOR_SPRITES+4)]  := $00_47_10_b0
    rend_sprites[constant(MOTOR_SPRITES+5)]  := $01_47_e0_b0
    rend_sprites[OIL_DRUM_SPRITE]            := $00_42_80_6f
    rend_sprites[OIL_DRUM_FLAME_SPRITE]      := $00_3C_81_5f
    rend_sprites[HAMMER_SPRITES]             := $00_1b_24_74
    rend_sprites[constant(HAMMER_SPRITES+1)] := $00_1b_7c_9b
    kong_conveyor_state_count:=0
    drum_state:=DRUM_LIT_LEVEL3
    drum_state_count:=0
    game_state := GAME_LEVEL_3

PRI InitLevel4 | i
    ' Rivets
    ClearMap(8)
    DrawFromData(@level4def)
    DrawStatus
    DrawBonusBox
    kong_real_x := $80
    kong_real_y := $37
    rend_sprites[MARIO_SPRITE]               := $04_00_3c_d7
    rend_sprites[HAMMER_SPRITES]             := $00_1b_1c_73
    rend_sprites[constant(HAMMER_SPRITES+1)] := $00_1b_7d_4b
    game_state := GAME_LEVEL_4
    remove_rivet_x := 0
    rivets_left:=1
    rivet_state_count:=30    

    
PRI ClimbScene | remove
    if (game_state_count)//2 == 0
        case game_state_count
            0:
                ClearMap(0)
                DrawStatus
                DrawFromData(@climbdef0)
            64:
                kong_real_y := $d0
                kong_real_x := $8c
                kong_pose_source:=@kong_back_right_with_pauline
                SetKongSprites
            72..312:
                if game_state_count//16 == 0
                    kong_pose_source:=@kong_back_right_with_pauline
                elseif game_state_count//16 == 8
                    kong_pose_source:=@kong_back_left_with_pauline
                if game_state_count//16 == 0 or game_state_count//16 == 8
                    kong_real_y-=4          
                    SetKongSprites
                    if game_state_count=>96
                        remove:=(kong_real_y>>3)+3 
                        byte[@climbdef72remove]:=remove
                        DrawFromData(@climbdef72e)
                        'DrawHorizontal(14,16,remove,gfx#TILE_SPACE)
                        case remove    
                            13,14:DrawFromData(@climbdef72a)     
                            17,18:DrawFromData(@climbdef72b)     
                            22:DrawFromData(@climbdef72c)
                            26:DrawFromData(@climbdef72d)
            346..389:
                kong_real_y-=lookupz((game_state_count-346)>>1: 3,3,3,3,3,3,3,2,2,2,2,2,2,1,1,1,1,0,0,-1,-1,-1)
                SetKongSprites
            390:
                SoundCrash
                kong_real_y++
                kong_pose_source:=@kong_center_sad_template
                SetKongSprites
                rend_sprites[PAULINE_SPRITES]             := $00_0f_70_17
                rend_sprites[constant(PAULINE_SPRITES+1)] := $00_10_70_17
                DrawFromData(@climbdef390)
            424..455:
                ClimbSceneKongJump(424)
            456:
                SoundCrash
                DrawFromData(@climbdef456)
            458..489:
                ClimbSceneKongJump(458)
            490:
                SoundCrash
                DrawFromData(@climbdef490)
            492..523:
                ClimbSceneKongJump(492)
            524:
                SoundCrash
                DrawFromData(@climbdef524)
            526..557:
                ClimbSceneKongJump(526)
            558:
                SoundCrash
                DrawFromData(@climbdef558)
            560..591:
                ClimbSceneKongJump(560)
            592:
                SoundCrash
                DrawFromData(@climbdef592)
            770:
                game_state := GAME_HOW_HIGH_INIT
    game_state_count++

PRI ClimbSceneKongJump(start_frame)
    kong_real_y-=lookupz((game_state_count-start_frame)>>1: 1,1,1,1,1,0,1,0,0,-1,0,-1,-1,-1,-1,-1)
    kong_real_x--
    SetKongSprites

PRI Level12EndScene
    case game_state_count
        0:
            EndLevelSpriteClear    
            rend_sprites[MARIO_SPRITE]                := $00_00_94_17
            rend_sprites[constant(PAULINE_SPRITES+1)] := $00_12_70_17
            rend_sprites[HEART_SPRITE]                := $00_52_82_1f
            kong_pose_source:=@kong_center_sad_template
            SetKongSprites
        32:
            kong_pose_source:=@kong_right_template
            SetKongSprites
            game_state:=GAME_LEVEL_123_FOLLOW_ON
    game_state_count++

PRI Level3EndScene
    if game_state_count==0
        EndLevelSpriteClear    
        rend_sprites[constant(PAULINE_SPRITES+1)] := $00_12_70_17
        rend_sprites[HEART_SPRITE]                := $00_52_82_1f
    ConveyorLogic
    KongLogic
    if kong_real_x==$5c
        game_state:=GAME_LEVEL_123_FOLLOW_ON
        game_state_count:=32

PRI Level123FollowOn
    case game_state_count
        64:
            kong_real_x := $5c
            kong_pose_source:=@kong_back_right
            SetKongSprites
        72..110:
            if game_state_count//16 == 0
                kong_real_y-=4
                kong_pose_source:=@kong_back_right
                SetKongSprites
            elseif game_state_count//16 == 8
                kong_real_y-=4
                kong_pose_source:=@kong_back_left
                SetKongSprites
        111:
            rend_sprites[PAULINE_SPRITES  ]           := $04_00_00_00
            rend_sprites[constant(PAULINE_SPRITES+1)] := $04_00_00_00
            rend_sprites[HEART_SPRITE]                := $00_53_82_1f
        112..160:
            if game_state_count//16 == 0
                kong_real_y-=4
                kong_pose_source:=@kong_back_right_with_pauline
                SetKongSprites
            elseif game_state_count//16 == 8
                kong_real_y-=4
                kong_pose_source:=@kong_back_left_with_pauline
                SetKongSprites
        168:
                kong_pose_source:=@kong_invisible
                SetKongSprites            
        286:
            game_level++
            game_state:=GAME_HOW_HIGH_INIT
    game_state_count++

PRI Level4EndScene | i
    case game_state_count
        0:
            EndLevelSpriteClear
            DrawFromData(@level4end1)
            rend_sprites[constant(PAULINE_SPRITES+1)] := $00_12_60_17
        40..160:
            if game_state_count//16==0
                kong_pose_source:=@kong_center_roar_l_template
                SetKongSprites
            elseif game_state_count//16==8        
                kong_pose_source:=@kong_center_roar_r_template
                SetKongSprites
        161:                
            kong_pose_source:=@kong_center_sad_template
            SetKongSprites
        192:
            kong_pose_source:=@kong_upsidedown_1
            SetKongSprites
        193..287:
            kong_real_y++
            SetKongSprites
        288:
            DrawFromData(@level4end2)
            rend_sprites[KONGS_STAR_SPRITE]           := $00_35_80_BF  
            rend_sprites[PAULINE_SPRITES]             := $00_0f_60_37
            rend_sprites[constant(PAULINE_SPRITES+1)] := $00_12_60_37
        320:                
            rend_sprites[MARIO_SPRITE]                := $00_00_84_37  
        352:
            rend_sprites[HEART_SPRITE]                := $00_52_72_37
        768:
            game_level++
            game_state:=GAME_HOW_HIGH_INIT

    if game_state_count=>288 and game_state_count=<536
        case game_state_count//24
            0:
                kong_pose_source:=@kong_upsidedown_2
                SetKongSprites
                rend_sprites[KONGS_STAR_SPRITE] ^= $01_00_00_00            
            8:
                kong_pose_source:=@kong_upsidedown_3
                SetKongSprites
                rend_sprites[KONGS_STAR_SPRITE] ^= $01_00_00_00            
            16:
                kong_pose_source:=@kong_upsidedown_4
                SetKongSprites
                rend_sprites[KONGS_STAR_SPRITE] ^= $01_00_00_00            
    game_state_count++

PRI MarioLogic | current_height, platform_height, ladder_top, ladder_bottom, delta, mario, i
    if frame & SPRITE_INVISIBLE<<8
        return
    mario := @rend_sprites[MARIO_SPRITE]
    current_height := byte[mario][SPRITE_YPOS]
    platform_height := PlatformHeight(byte[mario][SPRITE_XPOS],current_height) 
    ladder_top := LadderTopHeight(byte[mario][SPRITE_XPOS],current_height)
    ladder_bottom := LadderBottomHeight(byte[mario][SPRITE_XPOS],current_height)
    'debugdec(string("LADDER TOP"),ladder_top)
    'debugdec(string("PLATFORM HEIGHT"),platform_height)
    'debugdec(string("CURRENT HEIGHT"),current_height)
    ' decide on next state, and do any unique initialisations for that state
    if (gp&GP_B)
      hdmf1_state := HDMF__STATE_START_SONG
      hdmf1_song_start_ptr := @_SONG_hammer
      hdmf1_flags := HDMF__FLAG_LOOP_SONG

    if (mario_state=<MARIO_CLIMB_DOWN)
        'but only if we have user control
        if (gp&GP_A) and (gp&GP_LEFT) and not hammer_state_count
            mario_state:=MARIO_JUMP_LEFT
            frame := $00d
            mario_state_count:=0
            
        elseif (gp&GP_A) and (gp&GP_RIGHT) and not hammer_state_count
            mario_state:=MARIO_JUMP_RIGHT
            frame := $10d
            mario_state_count:=0
         
        elseif (gp & GP_A) and (mario_state==MARIO_FACING_LEFT) and not hammer_state_count
            mario_state:=MARIO_JUMP_UP_FACING_LEFT
            frame := $00d
            mario_state_count:=0
         
        elseif (gp & GP_A) and (mario_state==MARIO_FACING_RIGHT) and not hammer_state_count
            mario_state:=MARIO_JUMP_UP_FACING_RIGHT
            frame := $10d
            mario_state_count:=0
         
        elseif (gp & GP_LEFT) and (current_height==platform_height)
            'rotate(@mario_state_count,1,0,12)
            mario_state_count++
            if mario_state_count//3 <> 1
                byte[mario][SPRITE_XPOS]--
            mario_state:=MARIO_WALK_LEFT
         
        elseif (gp & GP_RIGHT) and (current_height==platform_height)
            'rotate(@mario_state_count,1,0,12)
            mario_state_count++
            if mario_state_count//3 <> 2
                byte[mario][SPRITE_XPOS]++
            mario_state:=MARIO_WALK_RIGHT
         
        elseif (gp & GP_UP) and (ladder_top<current_height) and not hammer_state_count
            if (mario_state<>MARIO_CLIMB_UP) and (mario_state<>MARIO_CLIMB_DOWN)
                mario_state_count:=0
            else
                mario_state_count++
            if mario_state_count//5==0
                byte[mario][SPRITE_YPOS]-=2
                byte[mario][SPRITE_YPOS]<#=platform_height
            mario_state:=MARIO_CLIMB_UP
                 
        elseif (gp & GP_DOWN) and (ladder_bottom>current_height) and not hammer_state_count
            if (mario_state<>MARIO_CLIMB_UP) and (mario_state<>MARIO_CLIMB_DOWN)
                mario_state_count:=0
            else
                mario_state_count--
            if mario_state_count//5==0
                byte[mario][SPRITE_YPOS]+=2
            mario_state:=MARIO_CLIMB_DOWN
         
        elseif (mario_state==MARIO_WALK_LEFT)
            mario_state:=MARIO_FACING_LEFT
         
        elseif (mario_state==MARIO_WALK_RIGHT)
            mario_state:=MARIO_FACING_RIGHT
    'DebugDec(@errortext,mario_state)
         
    'do the things that are common between states and that are done every game loop for a state
    if (mario_state==MARIO_CLIMB_DOWN) and (current_height==ladder_bottom-1)
        ' catch mario just before he goes below platform if he's on odd height.
        byte[mario][SPRITE_YPOS]:=ladder_bottom
        current_height:=ladder_bottom
    case mario_state
        MARIO_CLIMB_UP,MARIO_CLIMB_DOWN :
            case(ladder_bottom-current_height)/2
                0..1 : frame := 6
                other:
                    delta := (current_height-ladder_top)/2
                    'debugdec(string("DELTA"),delta)
                    'repeat 10000
                    case delta
                        -1000..-1: frame:=6 'negative number might happen with movable ladders?
                        0 : frame := 6
                        1 : frame := 3
                        2..3 : frame := 5
                        4..5 : frame := $104
                        other : frame := (delta//2)*$100+3
            byte[mario][SPRITE_XPOS]&=$F8
            byte[mario][SPRITE_XPOS]+=4
            if current_height==platform_height
                mario_state:=MARIO_FACING_LEFT                              'but, frame is facing away
                case game_state
                    GAME_LEVEL_1, GAME_LEVEL_2:
                        if current_height==23
                            game_state:=GAME_LEVEL_12_END_SCENE_INIT
                    GAME_LEVEL_3:
                        if current_height==55
                            game_state:=GAME_LEVEL_3_END_SCENE_INIT
                
        MARIO_WALK_LEFT, MARIO_WALK_RIGHT, MARIO_FACING_LEFT, MARIO_FACING_RIGHT:
            'deal with walking on platforms, inclines, lifts and falling   
            byte[mario][SPRITE_YPOS] := PlatformHeight(byte[mario][SPRITE_XPOS],byte[mario][SPRITE_YPOS])
            frame := lookupz(mario_state_count//12: 0,0,0,2,2,2,0,0,0,1,1,1)
            if hammer_state_count
                frame:=frame*2+7+((hammer_state_count>>3) & $01)
            if mario_state==MARIO_WALK_RIGHT or mario_state==MARIO_FACING_RIGHT 
                frame |= SPRITE_MIRRORED<<8
             
        MARIO_JUMP_LEFT:
            MarioLogicJump
            if mario_state_count//2==0
                byte[mario][SPRITE_XPOS]--                 
     
        MARIO_JUMP_RIGHT:
            MarioLogicJump
            if mario_state_count//2==0
                byte[mario][SPRITE_XPOS]++                 
     
        MARIO_JUMP_UP_FACING_LEFT:
            MarioLogicJump
     
        MARIO_JUMP_UP_FACING_RIGHT:
            MarioLogicJump
     
        MARIO_LANDING_LEFT:
            'deal with lifts  
            byte[mario][SPRITE_YPOS] := PlatformHeight(byte[mario][SPRITE_XPOS],byte[mario][SPRITE_YPOS])
            if mario_state_count==4
                mario_state:=MARIO_FACING_LEFT
                frame := $000
            else
                mario_state_count++
     
        MARIO_LANDING_RIGHT:
            'deal with lifts  
            byte[mario][SPRITE_YPOS] := PlatformHeight(byte[mario][SPRITE_XPOS],byte[mario][SPRITE_YPOS])
            if mario_state_count==4
                mario_state:=MARIO_FACING_RIGHT
                frame := $100
            else
                mario_state_count++
     
    'catch jump states that have past completion 
    case mario_state
        MARIO_JUMP_LEFT,MARIO_JUMP_UP_FACING_LEFT:
            if current_height>platform_height and mario_state_count>3 'At least 3 frames into the jump to avoid latching on to rising lifts
                mario_state:=MARIO_LANDING_LEFT
                frame:=$00e
                mario_state_count:=0
                byte[mario][SPRITE_YPOS]:=platform_height
            elseif byte[mario][SPRITE_XPOS]<25
                mario_state:=MARIO_JUMP_RIGHT
                frame := $10d
                
        MARIO_JUMP_RIGHT,MARIO_JUMP_UP_FACING_RIGHT:
            if current_height>platform_height and mario_state_count>3 'At least 3 frames into the jump to avoid latching on to rising lifts 
                mario_state:=MARIO_LANDING_RIGHT
                frame:=$10e
                mario_state_count:=0
                byte[mario][SPRITE_YPOS]:=platform_height
            elseif byte[mario][SPRITE_XPOS]>231
                mario_state:=MARIO_JUMP_LEFT
                frame := $00d

    'check for hammer collisions
    repeat i from HAMMER_SPRITES to constant(HAMMER_SPRITES+NUMBER_OF_HAMMERS-1)
        if not hammer_state_count and MarioCollision(i) 
            hammer_state_count:=683
            action_hammer:=i
            hdmf1_state := HDMF__STATE_START_SONG
            hdmf1_song_start_ptr := @_SONG_hammer
            hdmf1_flags := HDMF__FLAG_LOOP_SONG
            
    if hammer_state_count
        if ((hammer_state_count>>3) & $01)==0 or mario_state=>MARIO_JUMP_LEFT
            byte[@rend_sprites[action_hammer]][SPRITE_YPOS]:=byte[mario][SPRITE_YPOS]-16
            byte[@rend_sprites[action_hammer]][SPRITE_XPOS]:=byte[mario][SPRITE_XPOS]    
            word[@rend_sprites[action_hammer]][SPRITE_FLAGS_AND_TILE_WORD]:=$1b          
        else
            byte[@rend_sprites[action_hammer]][SPRITE_YPOS]:=byte[mario][SPRITE_YPOS]
            if mario_state==MARIO_FACING_LEFT or mario_state==MARIO_WALK_LEFT
                byte[@rend_sprites[action_hammer]][SPRITE_XPOS]:=byte[mario][SPRITE_XPOS]-16
                word[@rend_sprites[action_hammer]][SPRITE_FLAGS_AND_TILE_WORD]:=$1c       
            else
                byte[@rend_sprites[action_hammer]][SPRITE_XPOS]:=byte[mario][SPRITE_XPOS]+16    
                word[@rend_sprites[action_hammer]][SPRITE_FLAGS_AND_TILE_WORD]:=$11c
        hammer_state_count--
        if hammer_state_count==0
            byte[@rend_sprites[action_hammer]][SPRITE_FLAGS]:=SPRITE_INVISIBLE
            action_hammer:=0
            hdmf1_state := HDMF__STATE_START_SONG
            hdmf1_song_start_ptr := @_SONG_background_music
            hdmf1_flags := HDMF__FLAG_LOOP_SONG

    byte[mario][SPRITE_XPOS]#>=25        
    byte[mario][SPRITE_XPOS]<#=231
    word[mario][SPRITE_FLAGS_AND_TILE_WORD]:=frame
    
PRI MarioLogicJump
    'we lookup the y delta for each frame.  By offsetting by one, we ensure that overflow means one will be subtracted.
    byte[@rend_sprites[MARIO_SPRITE]][SPRITE_YPOS]-=lookupz(mario_state_count: 3,2,2,2,2,2,2,2,1,2,2,1,2,1,2,1,1,1,2,1,1,1,0,1,1,1,0,1,0,1,0,0,1)-1
    mario_state_count++
     
PRI KongLogic | i
    'debugdec(@kongstatetext,kong_state)
    kong_state_count++
    case kong_state
        KONG_LEVEL_START_POSE_INIT:
            kong_barrel_releases:=0
            kong_state_count := 0
            kong_pose_source:=@kong_center_sad_template
            SetKongSprites
            kong_state := KONG_LEVEL_START_POSE
        
        KONG_LEVEL_START_POSE:
            if kong_state_count == 64
                mario_state:=MARIO_WALK_RIGHT
                mario_state_count := 0
                'debugdec(string("MARIO STARTED"),0)
                frame := constant(SPRITE_MIRRORED<<8)
                if game_level//4
                    kong_state := KONG_NORMAL_INIT
                else
                    kong_state := KONG_BR_LEFT_INIT

        KONG_BR_LEFT_INIT:
            ' see if there's a barrel available.
            kong_holding_barrel := -1
            i := 0
            repeat while i<NUMBER_OF_BARRELS and kong_holding_barrel==-1
                if rend_sprites[MOVING_BARREL_SPRITES+i] & constant(SPRITE_INVISIBLE<<24)
                    kong_holding_barrel := i
                i++
            if kong_holding_barrel => 0
                barrel_state[kong_holding_barrel] := BARREL_STILL
                kong_state_count := 0
                kong_pose_source := @kong_left_template
                SetKongSprites
                kong_state := KONG_BR_LEFT
            'else stay in this state
                 
        KONG_BR_CENTER_1_INIT:
            ' keep barrel type
            'debugdec(@knongbarrelreleasestext,kong_barrel_releases)
            'repeat 1000000
                if kong_barrel_releases&$7 == 0
                    rend_sprites[MOVING_BARREL_SPRITES+kong_holding_barrel] := $00_19_3c_32
                else
                    rend_sprites[MOVING_BARREL_SPRITES+kong_holding_barrel] := $00_15_3c_32
            if kong_barrel_releases==0
                barrel_state[kong_holding_barrel] := BARREL_FALLING_DOWN
                kong_barrel_releases++                 
                kong_state := KONG_BR_CENTER_2_INIT
            else
                kong_state := KONG_BR_CENTER_1
            kong_state_count := 0
            kong_pose_source := @kong_center_barrel_template
            SetKongSprites
  
        KONG_BR_RIGHT_INIT:
            ' keep barrel type
            rend_sprites[MOVING_BARREL_SPRITES+kong_holding_barrel] -= $00_01_1E_00
            ' and add on x delta
            rend_sprites[MOVING_BARREL_SPRITES+kong_holding_barrel] += $00_00_3C_00
            kong_state_count := 0
            kong_pose_source := @kong_right_template
            SetKongSprites
            kong_state := KONG_BR_RIGHT

        KONG_BR_CENTER_2_INIT:
            'debugdec(@kongbarreltext, kong_holding_barrel)
            kong_state_count := 0
            kong_pose_source := @kong_center_sad_template
            SetKongSprites
            kong_state := KONG_BR_CENTER_2

        KONG_BR_GROWL_INIT:
            kong_state_count := 0
            kong_pose_source := @kong_center_roar_r_template
            SetKongSprites
            kong_state := KONG_BR_GROWL

        KONG_BR_LEFT:
            'debugdec(@kongstatecounttext,kong_state_count)
            if kong_state_count == 24
                kong_state := KONG_BR_CENTER_1_INIT

        KONG_BR_CENTER_1:
            if kong_state_count == 24
                kong_state := KONG_BR_RIGHT_INIT
                    
        KONG_BR_RIGHT:
            if kong_state_count == 24
                kong_state := KONG_BR_CENTER_2_INIT
                barrel_state[kong_holding_barrel]:=BARREL_ROLLING_RIGHT
                kong_holding_barrel := -3
                kong_barrel_releases++

        KONG_BR_CENTER_2:
            rnd := ?rnd
            if (rnd & $0000003F)==0
                kong_state := KONG_BR_GROWL_INIT
            elseif kong_state_count == 24
                kong_state := KONG_BR_LEFT_INIT

        KONG_BR_GROWL:
            if kong_state_count>24
                rnd := ?rnd
                if (rnd&$0000001F)==0  
                    kong_state := KONG_BR_LEFT_INIT

        KONG_NORMAL_INIT:
            kong_state_count:=0
            kong_pose_source := @kong_center_roar_r_template
            SetKongSprites
            kong_state := KONG_NORMAL
            
        KONG_NORMAL:
            case kong_state_count
                32,96:
                    kong_pose_source := @kong_center_roar_l_template
                    SetKongSprites
                64:
                    kong_pose_source := @kong_center_roar_r_template
                    SetKongSprites
                128:
                    kong_pose_source := @kong_center_sad_template
                    SetKongSprites
                256:
                    kong_state := KONG_NORMAL_INIT

PRI BarrelLogic | i, this_barrel, platform_height, height_to_fall, anim, mario, ladder_top_height
    mario := @rend_sprites[MARIO_SPRITE]
    repeat i from 0 to constant(NUMBER_OF_BARRELS-1)
        this_barrel := @rend_sprites[MOVING_BARREL_SPRITES+i]

        if HammerCollision(MOVING_BARREL_SPRITES+i)
            byte[this_barrel][SPRITE_FLAGS]:=SPRITE_INVISIBLE
            barrel_state[i]:=BARREL_STILL
            word[@rend_sprites[BONUS_SPRITE]][SPRITE_LOCATION_WORD] := word[this_barrel][SPRITE_LOCATION_WORD]
            bonus_state:=BONUS_BARREL_BUSTED_INIT                     
                                            
        if barrel_state[i]==BARREL_STILL
            next

        'debugdec(@barrelstatetext,barrel_state[i])
        platform_height := PlatformHeight(byte[this_barrel][SPRITE_XPOS],byte[this_barrel][SPRITE_YPOS])

        'check for barrel dissapearing into oil drum
        if byte[this_barrel][SPRITE_XPOS]==$28 and byte[this_barrel][SPRITE_YPOS]>200 and barrel_state[i]<>BARREL_STILL and barrel_state[i]<FIREBALL_JUMP_RIGHT_INIT
            if byte[this_barrel][SPRITE_TILE]==$18 and drum_state<>DRUM_FLARING
                drum_state := DRUM_FLARING_INIT
                barrel_state[i]:=FIREBALL_WAITING
                barrel_state_count[i]:=62
            else
                byte[this_barrel][SPRITE_FLAGS]:=SPRITE_INVISIBLE
                barrel_state[i]:=BARREL_STILL            
        case barrel_state[i]
            BARREL_ROLLING_RIGHT:
                BarrelLogicBarrelRolling(1,platform_height,this_barrel,mario,i,BARREL_FALLING_RIGHT,BARREL_ON_LADDER_RIGHT)
            BARREL_ROLLING_LEFT:
                BarrelLogicBarrelRolling(-1,platform_height,this_barrel,mario,i,BARREL_FALLING_LEFT,BARREL_ON_LADDER_LEFT)
            BARREL_FALLING_RIGHT:
                BarrelLogicBarrelFalling(1,BARREL_BOUNCING_LEFT,platform_height,this_barrel,i)
            BARREL_FALLING_LEFT:
                BarrelLogicBarrelFalling(-1,BARREL_BOUNCING_RIGHT,platform_height,this_barrel,i)
            BARREL_BOUNCING_RIGHT:
                BarrelLogicBarrelBouncing(1,BARREL_ROLLING_RIGHT,this_barrel,i)
            BARREL_BOUNCING_LEFT:
                BarrelLogicBarrelBouncing(-1,BARREL_ROLLING_LEFT,this_barrel,i)
            BARREL_ON_LADDER_RIGHT:
                BarrelLogicBarrelOnLadder(BARREL_ROLLING_LEFT,this_barrel,i)
{                if (byte[this_barrel][SPRITE_YPOS]) < BarrelLadderBottomHeight(byte[this_barrel][SPRITE_XPOS],byte[this_barrel][SPRITE_YPOS])
                    byte[this_barrel][SPRITE_YPOS]++    
                else
                    byte[this_barrel][SPRITE_TILE]--
                    barrel_state[i] := BARREL_ROLLING_LEFT    
}
            BARREL_ON_LADDER_LEFT:
                BarrelLogicBarrelOnLadder(BARREL_ROLLING_RIGHT,this_barrel,i)
{                if (byte[this_barrel][SPRITE_YPOS]) < BarrelLadderBottomHeight(byte[this_barrel][SPRITE_XPOS],byte[this_barrel][SPRITE_YPOS])
                    byte[this_barrel][SPRITE_YPOS]++    
                else
                    byte[this_barrel][SPRITE_TILE]--
                    barrel_state[i] := BARREL_ROLLING_RIGHT
}
            BARREL_FALLING_DOWN:
                height_to_fall := platform_height-(byte[this_barrel][SPRITE_YPOS])
                'debugdec(@heighttofalltext,height_to_fall)
                if height_to_fall>0 and height_to_fall<2 and barrel_state_count[i]>10
                    barrel_state_count[i]:=0
                    if platform_height>200
                        byte[this_barrel][SPRITE_YPOS]--
                        byte[this_barrel][SPRITE_TILE] := $18
                        barrel_state[i]:=BARREL_BOUNCING_LEFT
                else
                    ' offset by 2 so that any additional falls will be 2
                    byte[this_barrel][SPRITE_YPOS]+=lookupz(barrel_state_count[i]: -2,-2,-2,-2,-2,-2,-1,-2,-1,-2,-1,-2,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,0,-1,0,-1,0,-1)+2
                    barrel_state_count[i]++
            FIREBALL_WAITING:
                if barrel_state_count[i]-- == 0
                    fireball_real_y[i]:=byte[this_barrel][SPRITE_YPOS]
                    barrel_state[i]:=FIREBALL_JUMP_RIGHT_INIT
            FIREBALL_JUMP_RIGHT_INIT:
                BarrelLogicFireballJumpInit(this_barrel,i)
                word[this_barrel][SPRITE_FLAGS_AND_TILE_WORD] := $00_39
                barrel_state[i] := FIREBALL_JUMP_RIGHT
            FIREBALL_JUMP_LEFT_INIT:
                BarrelLogicFireballJumpInit(this_barrel,i)
                word[this_barrel][SPRITE_FLAGS_AND_TILE_WORD] := $01_39
                barrel_state[i] := FIREBALL_JUMP_LEFT
            FIREBALL_JUMP_RIGHT:
                BarrelLogicFireballJump(1,FIREBALL_BOUNCE_RIGHT_INIT,this_barrel,i)
            FIREBALL_JUMP_LEFT:
                BarrelLogicFireballJump(-1,FIREBALL_BOUNCE_LEFT_INIT,this_barrel,i)
            FIREBALL_BOUNCE_LEFT_INIT:
                rnd := ?rnd
                if rnd//4
                    barrel_state[i]:=FIREBALL_BOUNCE_LEFT
                else
                    barrel_state[i]:=FIREBALL_BOUNCE_RIGHT
                barrel_state_count[i]:=0
            FIREBALL_BOUNCE_RIGHT_INIT:
                rnd := ?rnd
                if rnd//4
                    barrel_state[i]:=FIREBALL_BOUNCE_RIGHT
                else
                    barrel_state[i]:=FIREBALL_BOUNCE_LEFT
                barrel_state_count[i]:=0
            FIREBALL_BOUNCE_RIGHT:
                BarrelLogicFireballBounce(1,$13a,$139,FIREBALL_BOUNCE_LEFT,FIREBALL_BOUNCE_RIGHT_INIT,this_barrel,i)
            FIREBALL_BOUNCE_LEFT:
                BarrelLogicFireballBounce(-1,$03a,$039,FIREBALL_BOUNCE_RIGHT,FIREBALL_BOUNCE_LEFT_INIT,this_barrel,i)
            FIREBALL_UP_LADDER:
                anim:=barrel_state_count[i]++ //16
                if anim==0
                    byte[this_barrel][SPRITE_TILE]:=$3a
                elseif anim==8
                    byte[this_barrel][SPRITE_TILE]:=$39
                if barrel_state_count[i]>35
                    barrel_state_count[i]:=0    
                if barrel_state_count[i] //4 ==0
                    platform_height := PlatformHeight(byte[this_barrel][SPRITE_XPOS],fireball_real_y[i])
                    if fireball_real_y[i] == platform_height
                        barrel_state[i]:=FIREBALL_BOUNCE_LEFT_INIT
                    fireball_real_y[i]--
            FIREBALL_DOWN_LADDER:
                anim:=barrel_state_count[i]-- //16
                if anim==0
                    byte[this_barrel][SPRITE_TILE]:=$3a
                elseif anim==8
                    byte[this_barrel][SPRITE_TILE]:=$39
                if barrel_state_count[i]<0
                    barrel_state_count[i]:=35    
                if barrel_state_count[i] //4 ==0
                    platform_height := PlatformHeight(byte[this_barrel][SPRITE_XPOS],fireball_real_y[i])
                    'debugdec(@currentheighttext,fireball_real_y[i])
                    'debugdec(@platformheighttext,platform_height)
                    if fireball_real_y[i] == platform_height
                        barrel_state[i]:=FIREBALL_BOUNCE_RIGHT_INIT
                        'debugdec(@currentheighttext,fireball_real_y[i])
                        'debugdec(@platformheighttext,platform_height)
                    fireball_real_y[i]++

        case barrel_state[i]
            BARREL_ROLLING_RIGHT,BARREL_ROLLING_LEFT,BARREL_FALLING_RIGHT,BARREL_FALLING_LEFT,BARREL_BOUNCING_RIGHT,BARREL_BOUNCING_LEFT:
                byte[this_barrel][SPRITE_FLAGS]:=lookupz(barrel_anim[i]>>3:%00,%10,%11,%01)    
                'debugdec(@barrelanimtext,byte[this_barrel][SPRITE_FLAGS])
            FIREBALL_JUMP_RIGHT_INIT,FIREBALL_JUMP_RIGHT,FIREBALL_JUMP_LEFT_INIT,FIREBALL_JUMP_LEFT,FIREBALL_BOUNCE_LEFT_INIT,FIREBALL_BOUNCE_RIGHT_INIT,FIREBALL_BOUNCE_LEFT,FIREBALL_BOUNCE_RIGHT,FIREBALL_MOVE_RIGHT,FIREBALL_UP_LADDER,FIREBALL_DOWN_LADDER,FIREBALL_WAITING:
                byte[this_barrel][SPRITE_YPOS] := fireball_real_y[i] - lookupz(barrel_state_count[i]/2: 0,1,1,2,2,2,2,2,2,2,2,2,2,1,1,0,1,0)

        if HammerCollision(MOVING_BARREL_SPRITES+i)
            byte[this_barrel][SPRITE_FLAGS]:=SPRITE_INVISIBLE
            barrel_state[i]:=BARREL_STILL
            word[@rend_sprites[BONUS_SPRITE]][SPRITE_LOCATION_WORD] := word[this_barrel][SPRITE_LOCATION_WORD]
            bonus_state:=BONUS_BARREL_BUSTED_INIT

PRI BarrelLogicBarrelRolling(delta,platform_height,this_barrel,mario,i,next_falling_state,next_ladder_state)
    if platform_height-(byte[this_barrel][SPRITE_YPOS]) > 3
        barrel_state_count[i]:=0
        barrel_state[i] := next_falling_state
    else 
        byte[this_barrel][SPRITE_XPOS]+=delta
        byte[this_barrel][SPRITE_YPOS]:=platform_height
    if byte[this_barrel][SPRITE_XPOS]&$07==4
        'check for ladders only when centred over tiles
        if BarrelLadderBottomHeight(byte[this_barrel][SPRITE_XPOS],byte[this_barrel][SPRITE_YPOS])>platform_height
            rnd:=?rnd
            'go down ladder randomly or brown barrel below mario 
            if rnd//8 == 0 or (byte[this_barrel][SPRITE_TILE]<>$18 and byte[this_barrel][SPRITE_YPOS]>PlatformHeight(byte[mario][SPRITE_XPOS],byte[mario][SPRITE_YPOS]))
                byte[this_barrel][SPRITE_YPOS]++
                byte[this_barrel][SPRITE_TILE]++
                barrel_state[i] := next_ladder_state
    rotate(@barrel_anim[i],delta,0,31) 

PRI BarrelLogicBarrelFalling(delta,next_bouncing_state,platform_height,this_barrel,i) | height_to_fall 
    height_to_fall := platform_height-(byte[this_barrel][SPRITE_YPOS])
    'debugdec(@heighttofalltext,height_to_fall)
    if height_to_fall < 0
        barrel_state_count[i]:=0
        barrel_state[i] := next_bouncing_state    
    else
        ' offset by 2 so that any additional falls will be 2
        byte[this_barrel][SPRITE_YPOS]+=lookupz(barrel_state_count[i]: -2,-2,-2,-2,-2,-2,-2,-2,-2,-1,-2,-2,-1,-1,-2,-1,-1,-1,-1,-2,0,-1,-1,-1,-1,0,-1,-1,0,-1)+2
        byte[this_barrel][SPRITE_XPOS]+=lookupz(barrel_state_count[i]:  1, 1, 1, 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 1, 0, 1, 0, 0, 1, 0,0, 1, 0, 1, 0,0, 1, 0,0, 1)*delta
        barrel_state_count[i]++
    rotate(@barrel_anim[i],delta,0,31)

PRI BarrelLogicBarrelBouncing(delta,next_rolling_state,this_barrel,i) 
    if barrel_state_count[i] =< 22
        byte[this_barrel][SPRITE_YPOS]-=lookupz(barrel_state_count[i]: 1,0,0,1,0,0,0,0,0,-1,0,0,-1,0,0,-1,0,1,0,0,0,0,-1)
        barrel_state_count[i]++                 
        byte[this_barrel][SPRITE_XPOS]+=delta
    else
        barrel_state[i]:=next_rolling_state
    rotate(@barrel_anim[i],delta,0,31)

PRI BarrelLogicBarrelOnLadder(next_state,this_barrel,i)
    if (byte[this_barrel][SPRITE_YPOS]) < BarrelLadderBottomHeight(byte[this_barrel][SPRITE_XPOS],byte[this_barrel][SPRITE_YPOS])
        byte[this_barrel][SPRITE_YPOS]++    
    else
        byte[this_barrel][SPRITE_TILE]--
        barrel_state[i] := next_state

PRI BarrelLogicFireballJumpInit(this_barrel,i)
    fireball_real_y[i]:=byte[@rend_sprites[OIL_DRUM_SPRITE]][SPRITE_YPOS]-7
    byte[this_barrel][SPRITE_XPOS]:=byte[@rend_sprites[OIL_DRUM_SPRITE]][SPRITE_XPOS]
    byte[this_barrel][SPRITE_YPOS]:=fireball_real_y
    barrel_state_count[i]:=0

PRI BarrelLogicFireballJump(delta,next_state,this_barrel,i)
    if barrel_state_count[i]//2 == 0
        fireball_real_y[i]+=lookupz(barrel_state_count[i] >>1: -2,-2,-2,-1,-1,-1,-1,-1,-1,0,-1,0,0,0,0,0,1,0,1,1,1,1,1,1,1,1,2,2,2,2,2)
        byte[this_barrel][SPRITE_XPOS]+=delta
    barrel_state_count[i]++
    if fireball_real_y[i]=>PlatformHeight(byte[this_barrel][SPRITE_XPOS],fireball_real_y[i])
        barrel_state[i] := next_state

PRI BarrelLogicFireballBounce(delta,frame1,frame2,next_reverse_state,next_continue_state,this_barrel,i) | platform_height, anim, ladder_top_height
    platform_height := PlatformHeight(byte[this_barrel][SPRITE_XPOS],fireball_real_y[i])
    anim:=barrel_state_count[i]++ //16
    if anim==0
        word[this_barrel][SPRITE_FLAGS_AND_TILE_WORD]:=frame1
    elseif anim==8
        word[this_barrel][SPRITE_FLAGS_AND_TILE_WORD]:=frame2
    if anim//2 
        byte[this_barrel][SPRITE_XPOS]+=delta
        platform_height := PlatformHeight(byte[this_barrel][SPRITE_XPOS],fireball_real_y[i])
        if platform_height-fireball_real_y[i]>3
            byte[this_barrel][SPRITE_XPOS]-=delta
            barrel_state[i] := next_reverse_state
        else
            fireball_real_y[i]:=platform_height
    if barrel_state_count[i]==35
        barrel_state[i]:=next_continue_state
    if byte[this_barrel][SPRITE_XPOS]&$07==4
        'check for ladders only when centred over tiles
        if BarrelLadderBottomHeight(byte[this_barrel][SPRITE_XPOS],fireball_real_y[i])>platform_height
            rnd:=?rnd
            if rnd//3 == 0
                barrel_state_count[i]:=0
                barrel_state[i] := FIREBALL_DOWN_LADDER
        ladder_top_height:=LadderTopHeight(byte[this_barrel][SPRITE_XPOS],fireball_real_y[i])
        if ladder_top_height<platform_height and ladder_top_height>23
            'There is a ladder above, but it isn't Pauline's
            rnd:=?rnd
            if rnd//3 == 0
                barrel_state_count[i]:=0
                barrel_state[i] := FIREBALL_UP_LADDER
     
PRI DrumLogic | found,i
    case drum_state
        DRUM_FLARING_INIT:
            drum_state_count:=62
            rnd := ?rnd
            drum_flicker_count:=rnd&$b + 4
            rend_sprites[OIL_DRUM_FLAME_SPRITE] := $00_3D_28_c8
            drum_state := DRUM_FLARING
        DRUM_FLARING:
            if drum_flicker_count-- == 0
                rend_sprites[OIL_DRUM_FLAME_SPRITE] ^= $00_03_00_00 'swap between $3d and 3E
                rnd := ?rnd
                drum_flicker_count:=rnd&$b + 4
            'debugdec(@barrelstatetext,drum_state_count)
            if drum_state_count-- == 0
                drum_state := DRUM_LIT_INIT
        DRUM_LIT_INIT:
            rnd := ?rnd
            drum_flicker_count:=rnd&$b + 4
            rend_sprites[OIL_DRUM_FLAME_SPRITE] := $00_3C_29_c8
            drum_state := DRUM_LIT
        DRUM_LIT:
            if drum_flicker_count-- == 0
                rend_sprites[OIL_DRUM_FLAME_SPRITE] ^= $00_07_00_00 'swap between $3b and 3c
                rnd := ?rnd
                drum_flicker_count:=rnd&$b + 4
        DRUM_LIT_LEVEL3:
            if drum_flicker_count-- == 0
                rend_sprites[OIL_DRUM_FLAME_SPRITE] ^= $00_07_00_00 'swap between $3b and 3c
                rnd := ?rnd
                drum_flicker_count:=rnd&$b + 4
            if byte[@rend_sprites[MARIO_SPRITE]][SPRITE_XPOS]>$80
                case drum_state_count++
                    204:    barrel_state[0]:=FIREBALL_JUMP_RIGHT_INIT
                    268:    barrel_state[1]:=FIREBALL_JUMP_RIGHT_INIT
                    316:    barrel_state[2]:=FIREBALL_JUMP_RIGHT_INIT
                    2156:   barrel_state[3]:=FIREBALL_JUMP_RIGHT_INIT
                    4204:   barrel_state[4]:=FIREBALL_JUMP_RIGHT_INIT
            else
                case drum_state_count++
                    204:    barrel_state[0]:=FIREBALL_JUMP_LEFT_INIT
                    268:    barrel_state[1]:=FIREBALL_JUMP_LEFT_INIT
                    316:    barrel_state[2]:=FIREBALL_JUMP_LEFT_INIT
                    2156:   barrel_state[3]:=FIREBALL_JUMP_LEFT_INIT
                    4204:   barrel_state[4]:=FIREBALL_JUMP_LEFT_INIT 

PRI PaulineLogic
    case pauline_state
        PAULINE_STILL_INIT:
            case game_state
                GAME_LEVEL_1..GAME_LEVEL_3:
                    rend_sprites[PAULINE_SPRITES]   := $00_0f_70_17
                    rend_sprites[PAULINE_SPRITES+1] := $00_10_70_17
                    word[rend_map][15] := gfx#TILE_SPACE
                    word[rend_map][16] := gfx#TILE_SPACE
                    word[rend_map][17] := gfx#TILE_SPACE
                GAME_LEVEL_4:
                    rend_sprites[PAULINE_SPRITES]   := $00_0f_60_17
                    rend_sprites[PAULINE_SPRITES+1] := $00_10_60_17
                    word[rend_map][13] := gfx#TILE_SPACE
                    word[rend_map][14] := gfx#TILE_SPACE
                    word[rend_map][15] := gfx#TILE_SPACE
            pauline_state := PAULINE_STILL
            pauline_state_count := 192
        PAULINE_STILL:
            pauline_state_count--
            if pauline_state_count == 0
                pauline_state := PAULINE_SCREAM_INIT
        PAULINE_SCREAM_INIT:
            case game_state
                GAME_LEVEL_1..GAME_LEVEL_3:
                    rend_sprites[PAULINE_SPRITES]   := $00_0f_70_17
                    rend_sprites[PAULINE_SPRITES+1] := $00_10_70_17
                    word[rend_map][15] := gfx#TILE_HELP
                    word[rend_map][16] := constant(gfx#TILE_HELP+1) 
                    word[rend_map][17] := constant(gfx#TILE_HELP+2) 
                GAME_LEVEL_4:
                    rend_sprites[PAULINE_SPRITES]   := $00_0f_60_17
                    rend_sprites[PAULINE_SPRITES+1] := $00_10_60_17
                    word[rend_map][13] := gfx#TILE_HELP 
                    word[rend_map][14] := constant(gfx#TILE_HELP+1) 
                    word[rend_map][15] := constant(gfx#TILE_HELP+2)                 
            pauline_state := PAULINE_SCREAM
            pauline_state_count := 64
        PAULINE_SCREAM:
            pauline_state_count--
            if pauline_state_count//8 == 0
                rend_sprites[PAULINE_SPRITES+1] ^= $00_01_00_00
            if pauline_state_count == 0
                pauline_state := PAULINE_STILL_INIT

PRI LiftLogic | i, mario, mario_x, mario_y, distance
    mario := @rend_sprites[MARIO_SPRITE]
    if lift_state_count-- == 0
        lift_state_count := 1
        repeat i from LIFT_SPRITES to constant(LIFT_SPRITES+2)
            byte[@rend_sprites[i]][SPRITE_YPOS]--
            if byte[@rend_sprites[i]][SPRITE_YPOS]<58
                byte[@rend_sprites[i]][SPRITE_YPOS]+=$9c
        repeat i from constant(LIFT_SPRITES+3) to constant(LIFT_SPRITES+5)
            byte[@rend_sprites[i]][SPRITE_YPOS]++
            if byte[@rend_sprites[i]][SPRITE_YPOS]>58+$9c
                byte[@rend_sprites[i]][SPRITE_YPOS]-=$9c

PRI SpringLogic | i
    'There are 25 elements in the bounce YPOS lookup.  Each is matched by 2 added to XPOS = 50 per bounce.
    'So 4 bounces gets across the screen to where we drop.  Drop is 3 pixels per frame.
    repeat i from 0 to constant(NUMBER_OF_SPRINGS-1)
        case spring_state_count[i]
            0..99: 
                byte[@rend_sprites[SPRING_SPRITES+i]][SPRITE_YPOS]+=lookupz(spring_state_count[i]//25: -3,-3,-3,-2,-2,-2,-2,-1,-1,0,-1,0,0,1,0,1,1,2,2,2,2,3,3,3,0)
                spring_real_x[i]+=2
            100..198:
                byte[@rend_sprites[SPRING_SPRITES+i]][SPRITE_YPOS]+=2
            199:
                spring_state_count[i] := -1
                rnd := ?rnd
                spring_real_x[i] := -7 + rnd&$F
                byte[@rend_sprites[SPRING_SPRITES+i]][SPRITE_YPOS]:=$37
        if spring_real_x[i]=>8
            byte[@rend_sprites[SPRING_SPRITES+i]][SPRITE_XPOS] := spring_real_x[i]
            'if (spring_state_count[i]+5)//25<10
            if spring_state_count[i]//32<16
                word[@rend_sprites[SPRING_SPRITES+i]][SPRITE_FLAGS_AND_TILE_WORD]:=$38
            else
                word[@rend_sprites[SPRING_SPRITES+i]][SPRITE_FLAGS_AND_TILE_WORD]:=$37
        else
                word[@rend_sprites[SPRING_SPRITES+i]][SPRITE_FLAGS_AND_TILE_WORD]:=constant(SPRITE_INVISIBLE<<8)                        
        spring_state_count[i]++

PRI Ladderlogic | i
    repeat i from 0 to constant(NUMBER_OF_LADDERS-1)
        case ladder_state[i]
            LADDER_UP:
                case ladder_state_count[i]++
                    0:  SetTile(4+23*i, 8, gfx#TILE_INVISIBLE_LADDER)
                        SetTile(4+23*i, 9, gfx#TILE_INVISIBLE_LADDER)
                    255:
                        if i==0
                            ladder_state_count[i] := 0
                            ladder_state[i] := LADDER_GOING_DOWN
                    273:
                        if i==1
                            ladder_state_count[i] := 0
                            ladder_state[i] := LADDER_GOING_DOWN
            LADDER_GOING_DOWN:
                case ladder_state_count[i]++
                    0:  SetTile(4+23*i, 8, gfx#TILE_SPACE)
                        SetTile(4+23*i, 9, gfx#TILE_SPACE)
                    127:
                        ladder_state_count[i] := 0
                        ladder_state[i] := LADDER_DOWN
                if ladder_state_count[i]//8==0
                    'Move Mario down if he's on ladder
                    if byte[@rend_sprites[MARIO_SPRITE]][SPRITE_XPOS]==byte[@rend_sprites[LADDER_SPRITES+i]][SPRITE_XPOS]
                        if byte[@rend_sprites[MARIO_SPRITE]][SPRITE_XPOS]=<byte[@rend_sprites[LADDER_SPRITES+i]][SPRITE_XPOS] and byte[@rend_sprites[MARIO_SPRITE]][SPRITE_XPOS]=>byte[@rend_sprites[LADDER_SPRITES+i]][SPRITE_XPOS]-15
                            if TileAt(byte[@rend_sprites[MARIO_SPRITE]][SPRITE_XPOS],byte[@rend_sprites[MARIO_SPRITE]][SPRITE_YPOS])<>gfx#TILE_FULL_LADDER
                                 byte[@rend_sprites[MARIO_SPRITE]][SPRITE_YPOS]++
                    'Move ladder down  
                    byte[@rend_sprites[LADDER_SPRITES+i]][SPRITE_YPOS]++
                        
            LADDER_DOWN:
                case ladder_state_count[i]++
                    15:
                        ladder_state_count[i] := 0
                        ladder_state[i] := LADDER_GOING_UP            
            LADDER_GOING_UP:
                case ladder_state_count[i]++
                    63:
                        ladder_state_count[i] := 0
                        ladder_state[i] := LADDER_UP
                if ladder_state_count[i]//4==0
                    byte[@rend_sprites[LADDER_SPRITES+i]][SPRITE_YPOS]--

PRI ConveyorLogic | pie_available, i
    'move existing pies
    if conveyor_state_count++//2==0
        repeat i from 0 to constant(NUMBER_OF_PIES-1)
            if not byte[@rend_sprites[PIE_SPRITES+i]][SPRITE_FLAGS]&SPRITE_INVISIBLE
                if byte[@rend_sprites[PIE_SPRITES+i]][SPRITE_YPOS]==$af
                    'it's on the bottom conveyor
                    case bottom_conveyor_state
                        CONVEYOR_RIGHT:
                            byte[@rend_sprites[PIE_SPRITES+i]][SPRITE_XPOS]++
                            if byte[@rend_sprites[PIE_SPRITES+i]][SPRITE_XPOS]==$F1
                                byte[@rend_sprites[PIE_SPRITES+i]][SPRITE_FLAGS]:=SPRITE_INVISIBLE    
                        CONVEYOR_LEFT:
                            byte[@rend_sprites[PIE_SPRITES+i]][SPRITE_XPOS]--
                            if byte[@rend_sprites[PIE_SPRITES+i]][SPRITE_XPOS]==$0F
                                byte[@rend_sprites[PIE_SPRITES+i]][SPRITE_FLAGS]:=SPRITE_INVISIBLE
                elseif byte[@rend_sprites[PIE_SPRITES+i]][SPRITE_XPOS]<$80
                    'it's on the middle left conveyor
                    case middle_left_conveyor_state
                        CONVEYOR_RIGHT:
                            byte[@rend_sprites[PIE_SPRITES+i]][SPRITE_XPOS]++
                            if byte[@rend_sprites[PIE_SPRITES+i]][SPRITE_XPOS]==$80
                                byte[@rend_sprites[PIE_SPRITES+i]][SPRITE_FLAGS]:=SPRITE_INVISIBLE    
                        CONVEYOR_LEFT:
                            byte[@rend_sprites[PIE_SPRITES+i]][SPRITE_XPOS]--
                            if byte[@rend_sprites[PIE_SPRITES+i]][SPRITE_XPOS]==$0F
                                byte[@rend_sprites[PIE_SPRITES+i]][SPRITE_FLAGS]:=SPRITE_INVISIBLE
                else
                    'it's on the middle right conveyor
                     case middle_right_conveyor_state
                        CONVEYOR_RIGHT:
                            byte[@rend_sprites[PIE_SPRITES+i]][SPRITE_XPOS]++
                            if byte[@rend_sprites[PIE_SPRITES+i]][SPRITE_XPOS]==$F1
                                byte[@rend_sprites[PIE_SPRITES+i]][SPRITE_FLAGS]:=SPRITE_INVISIBLE    
                        CONVEYOR_LEFT:
                            byte[@rend_sprites[PIE_SPRITES+i]][SPRITE_XPOS]--
                            if byte[@rend_sprites[PIE_SPRITES+i]][SPRITE_XPOS]==$80
                                byte[@rend_sprites[PIE_SPRITES+i]][SPRITE_FLAGS]:=SPRITE_INVISIBLE
        'move mario
        if byte[@rend_sprites[MARIO_SPRITE]][SPRITE_YPOS]==$af
            'Mario's on the bottom conveyor
            case bottom_conveyor_state
                CONVEYOR_RIGHT:
                    byte[@rend_sprites[MARIO_SPRITE]][SPRITE_XPOS]++
                CONVEYOR_LEFT:
                    byte[@rend_sprites[MARIO_SPRITE]][SPRITE_XPOS]--
        elseif byte[@rend_sprites[MARIO_SPRITE]][SPRITE_YPOS]==$5f
            if byte[@rend_sprites[MARIO_SPRITE]][SPRITE_XPOS]<$80
                'Mario's on the middle left conveyor
                case middle_left_conveyor_state
                    CONVEYOR_RIGHT:
                        byte[@rend_sprites[MARIO_SPRITE]][SPRITE_XPOS]++
                    CONVEYOR_LEFT:
                        byte[@rend_sprites[MARIO_SPRITE]][SPRITE_XPOS]--
            else
                'Mario's on the middle right conveyor
                 case middle_right_conveyor_state
                    CONVEYOR_RIGHT:
                        byte[@rend_sprites[MARIO_SPRITE]][SPRITE_XPOS]++
                    CONVEYOR_LEFT:
                        byte[@rend_sprites[MARIO_SPRITE]][SPRITE_XPOS]--
                     

    'move kong and change direction of conveyors                
    case kong_conveyor_state
        CONVEYOR_RIGHT:
            if kong_conveyor_state_count//2==0
                kong_real_x++
                SetKongSprites
            kong_conveyor_state_count++
            if kong_conveyor_state_count==128
                middle_left_conveyor_state ^= 1
            if kong_conveyor_state_count==256
                kong_conveyor_state:=CONVEYOR_LEFT
        CONVEYOR_LEFT:
            if kong_conveyor_state_count//2==0
                kong_real_x--
                SetKongSprites
            kong_conveyor_state_count--
            if kong_conveyor_state_count==0
                kong_conveyor_state:=CONVEYOR_RIGHT
                bottom_conveyor_state ^= 1
            if kong_conveyor_state_count==128
                middle_right_conveyor_state ^= 1
    'create pies
    if pie_state_count++ == 125
        pie_available := -1
        repeat i from 0 to constant(NUMBER_OF_PIES-1)
            if byte[@rend_sprites[PIE_SPRITES+i]][SPRITE_FLAGS]&SPRITE_INVISIBLE
                pie_available := i
                quit
        if pie_available=>0
            repeat
                rnd := ?rnd
                case rnd&$3
                    0:
                        if middle_left_conveyor_state==CONVEYOR_RIGHT
                            rend_sprites[PIE_SPRITES+i] := $00_43_10_5f
                            quit    
                    1:
                        if middle_right_conveyor_state==CONVEYOR_LEFT
                            rend_sprites[PIE_SPRITES+i] := $00_43_F0_5f
                            quit       
                    2:
                        if bottom_conveyor_state==CONVEYOR_RIGHT
                            rend_sprites[PIE_SPRITES+i] := $00_43_10_af
                            quit         
                    3:
                        if bottom_conveyor_state==CONVEYOR_LEFT
                            rend_sprites[PIE_SPRITES+i] := $00_43_F0_af
                            quit  
        pie_state_count := 0

PRI RivetLogic | x, y, i
    if rivets_left == 0
        game_state:=GAME_LEVEL_4_END_SCENE_INIT
    
    x := byte[@rend_sprites[MARIO_SPRITE]][SPRITE_XPOS]
    y := ((byte[@rend_sprites[MARIO_SPRITE]][SPRITE_YPOS]-16)/40)*40+55
    'debugdec(string("YT"),y)
    'debugdec(string("tile"),TileAt(x,y))
    if TileAt(x,y)==gfx#TILE_TOP_OF_RIVET
        'store coords to remove once mario steps off
        remove_rivet_x:=x
        remove_rivet_y:=y
    elseif remove_rivet_x>0
        SetTile((remove_rivet_x>>3),(remove_rivet_y>>3),gfx#TILE_SPACE)
        SetTile((remove_rivet_x>>3),(remove_rivet_y>>3)+1,gfx#TILE_SPACE)
        remove_rivet_x:=0
        rivets_left--

    i:=rivet_state_count++ >>8
    if rivet_state_count&$FF==0 and i<5 
        rnd:=?rnd
        if byte[@rend_sprites[MARIO_SPRITE]][SPRITE_XPOS]<$80
            barrel_state[i]:=FIREBALL_BOUNCE_LEFT_INIT
            case rnd&3
                0:
                    rend_sprites[MOVING_BARREL_SPRITES+i] := $01_45_d7_5f
                    fireball_real_y[i]:=$5f
                1:
                    rend_sprites[MOVING_BARREL_SPRITES+i] := $01_45_df_87  
                    fireball_real_y[i]:=$87
                2:
                    rend_sprites[MOVING_BARREL_SPRITES+i] := $01_45_e7_af  
                    fireball_real_y[i]:=$af
                3:
                    rend_sprites[MOVING_BARREL_SPRITES+i] := $01_45_ef_d7  
                    fireball_real_y[i]:=$d7
        else
            barrel_state[i]:=FIREBALL_BOUNCE_RIGHT_INIT
            case rnd&3
                0:
                    rend_sprites[MOVING_BARREL_SPRITES+i] := $00_45_28_5f
                    fireball_real_y[i]:=$5f
                1:
                    rend_sprites[MOVING_BARREL_SPRITES+i] := $00_45_20_87  
                    fireball_real_y[i]:=$87
                2:
                    rend_sprites[MOVING_BARREL_SPRITES+i] := $00_45_18_af  
                    fireball_real_y[i]:=$af
                3:
                    rend_sprites[MOVING_BARREL_SPRITES+i] := $00_45_10_d7  
                    fireball_real_y[i]:=$d7

PRI BonusLogic
    'in play bonuses
    case bonus_state
        BONUS_BARREL_BUSTED_INIT:
            bonus_state_count:=0
            bonus_freeze:=TRUE
            bonus_state:=BONUS_BARREL_BUSTED
        BONUS_BARREL_BUSTED:
            case bonus_state_count
                0,16,32: word[@rend_sprites[BONUS_SPRITE]][SPRITE_FLAGS_AND_TILE_WORD] := 74
                8,24,40: word[@rend_sprites[BONUS_SPRITE]][SPRITE_FLAGS_AND_TILE_WORD] := 75
                48: word[@rend_sprites[BONUS_SPRITE]][SPRITE_FLAGS_AND_TILE_WORD] := 76
                60: word[@rend_sprites[BONUS_SPRITE]][SPRITE_FLAGS_AND_TILE_WORD] := 77
                73:
                    word[@rend_sprites[BONUS_SPRITE]][SPRITE_FLAGS_AND_TILE_WORD] := gfx#SPRITE_SCORE_300
                    AddToScore(300)
                    bonus_freeze:=FALSE
                137:
                    byte[@rend_sprites[BONUS_SPRITE]][SPRITE_FLAGS] := SPRITE_INVISIBLE
                    bonus_state:=BONUS_NONE
    bonus_state_count++
    'timer bonus
    if --timer_state_count == 0
        SubFromTimer(100)
        timer_state_count := 128

    if timer==0
        mario_state := MARIO_DEAD_INIT
        
    return not bonus_freeze
     
PRI SoundLogic
    'START SONG >>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
    if hdmf1_state == HDMF__STATE_START_SONG

      'Init flags
      hdmf1_flags &= !(HDMF__FLAG_LAST_NOTE_5_BYTES)
      hdmf1_flags |= HDMF__FLAG_FIRST_NOTE
      
      'Read instruments
      hdmf1_song_ptr := hdmf1_song_start_ptr
      repeat hdmf1_i from 0 to HDMF_MAX_INSTRUMENTS - 1
        hdmf1_instrument_wave[hdmf1_i] := byte[hdmf1_song_ptr]
        ++hdmf1_song_ptr
        hdmf1_instrument_envelope[hdmf1_i] := byte[hdmf1_song_ptr] | byte[hdmf1_song_ptr+1] << 8 | byte[hdmf1_song_ptr+2] << 16 | byte[hdmf1_song_ptr+3] << 24
        hdmf1_song_ptr += 4
        
      'skip over 'end of instruments' 0xff
      ++hdmf1_song_ptr
      
      hdmf1_state := HDMF__STATE_PLAY_FETCH

    'FETCH NOTE >>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>> 
    elseif hdmf1_state == HDMF__STATE_PLAY_FETCH
      'Fetch song data from RAM
      if hdmf1_flags & HDMF__FLAG_LAST_NOTE_5_BYTES
        'One byte of note data already in buffer.  Read 5 more.
        repeat hdmf1_i from 1 to 5
          hdmf1_note_data[hdmf1_i] := byte[hdmf1_song_ptr]
          hdmf1_song_ptr++
      else
        'Read 6 new bytes of note data
        repeat hdmf1_i from 0 to 5
          hdmf1_note_data[hdmf1_i] := byte[hdmf1_song_ptr]  
          hdmf1_song_ptr++
          
      hdmf1_note_delta_time := hdmf1_note_data[0] * HDMF_TIMEBASE_TICK  

      'Init the note timebase on the first note played
      if hdmf1_flags & HDMF__FLAG_FIRST_NOTE
        hdmf1_current_note_time := cnt
       
      'If not end of song
      if (hdmf1_note_data[0] <> $ff)
        
        hdmf1_P_time := hdmf1_current_note_time + hdmf1_note_delta_time
        hdmf1_P_channel := (hdmf1_note_data[1] & $e0) >> 5
        hdmf1_P_freq := (((hdmf1_note_data[1] & $1f) << 8) | hdmf1_note_data[2] ) << 1
        hdmf1_P_volume := hdmf1_note_data[3] << 3
        hdmf1_P_instrument := (hdmf1_note_data[3] & $e0) >> 5
     
        if hdmf1_note_data[4] & $80
          hdmf1_P_duration := ((hdmf1_note_data[4] & $7f) << 8 | hdmf1_note_data[5]) * HDMF_DURATION_TICK
          hdmf1_flags &= !HDMF__FLAG_LAST_NOTE_5_BYTES
        else
          hdmf1_P_duration := hdmf1_note_data[4] * HDMF_DURATION_TICK
          'Note was only 5 bytes long, so save the 6th byte for the next note
          hdmf1_note_data[0] := hdmf1_note_data[5]
          hdmf1_flags |= HDMF__FLAG_LAST_NOTE_5_BYTES

        'Enter the wait state (note will play when its scheduled time arrives)
        hdmf1_state := HDMF__STATE_PLAY_WAIT
      else
        'Song over.
        if hdmf1_flags & HDMF__FLAG_LOOP_SONG
          'Looping.  Restart song from beginning.
          hdmf1_song_ptr := hdmf1_song_start_ptr + CONSTANT(5*8 + 1)
          hdmf1_state := HDMF__STATE_PLAY_FETCH
          hdmf1_flags &= !HDMF__FLAG_LAST_NOTE_5_BYTES   
        else
          'Done. Enter idle state.
          hdmf1_state := HDMF__STATE_IDLE

    'WAIT NOTE >>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
    elseif hdmf1_state == HDMF__STATE_PLAY_WAIT
      OUTA [0] := !INA[0] 'Toggle debug LED     
      'If not waiting to cross end of counter wrap
      if not (((hdmf1_current_note_time>>1) > $40000000) and ((hdmf1_P_time>>1) < $40000000) and ((cnt>>1) > $40000000))
        'If note's scheduled play time is reached
        if ((cnt>>1) => (hdmf1_P_time>>1))
          sfx.PlaySoundFM(hdmf1_P_channel, {snd#SHAPE_SINE} hdmf1_instrument_wave[hdmf1_P_instrument], hdmf1_P_freq, hdmf1_P_duration, hdmf1_P_volume, hdmf1_instrument_envelope[hdmf1_P_instrument] )
          hdmf1_current_note_time := hdmf1_P_time
          'Enter the fetch state to fetch the next note
          hdmf1_state := HDMF__STATE_PLAY_FETCH
        
PRI Rotate(item_ptr,increment,lower,upper)
    ' Rotate a byte value through a range of values.  Useful for sprite animation.
    ' byte_item = pointer to a variable to ,reset,lower,upper)
    ' increment = value to add or subtract
    ' lower     = lower bound
    ' upper     = upper bound
    long[item_ptr]+=increment
    if long[item_ptr]>upper
        long[item_ptr] := lower
    if long[item_ptr]<lower
        long[item_ptr] := upper
    return

PRI TileAt(px,py) | pos
    if py>223
        if py>231
            return gfx#TILE_FULL_PLATFORM               ' An empty space to avoid it looking like there is a ladder going down
        return gfx#TILE_SPACE                  ' A full platform so that platfor_height always returns a value 
    pos := (px>>3+(py>>3)*32)<<1
    return byte[rend_map][pos]
    
PRI SetTile(tx,ty,tile) | pos
    pos := (tx+ty*32)<<1
    byte[rend_map][pos] := tile
    
PRI TileHeight(tile)    
    if (tile=>gfx#TILE_FULL_PLATFORM_LADDER_TILE and tile=<gfx#TILE_START_OF_LADDER_TILES)
        return tile-gfx#TILE_FULL_PLATFORM_LADDER_TILE
    if (tile=>gfx#TILE_FULL_PLATFORM and tile=<gfx#TILE_END_OF_PLATFORM_TILES)
        return tile-gfx#TILE_FULL_PLATFORM
    return 0

PRI PlatformHeight(_x,_y) | background, i, distance
    ' Calculates the position of one pixel above height of the platform where we are.
    ' If we are stood on the platform it's where our feet are.
    ' If our feet are overlapping a platform it's the top of that.(To cope with inclines.)
    ' Otherwise it's the first platform below.
    if game_state == GAME_LEVEL_2
        if _x=>$30 and _x<$40
            repeat i from LIFT_SPRITES to constant(LIFT_SPRITES+2)
                distance := _y-byte[@rend_sprites[i]][SPRITE_YPOS]
                case distance
                    -3..3: return byte[@rend_sprites[i]][SPRITE_YPOS]
        if _x=>$70 and _x<$80
            repeat i from constant(LIFT_SPRITES+3) to constant(LIFT_SPRITES+5)
                distance := _y-byte[@rend_sprites[i]][SPRITE_YPOS]
                case distance
                    -3..3: return byte[@rend_sprites[i]][SPRITE_YPOS]
    repeat
        background := TileAt(_x,_y)
        'debugdec(string("TILE"),background)
        case background
            gfx#TILE_FULL_PLATFORM_LADDER_TILE..gfx#TILE_END_OF_LADDER_TILES:
                'top of platform
                return (_y & $F8)+(background-gfx#TILE_START_OF_LADDER_TILES)      
            gfx#TILE_FULL_PLATFORM..gfx#TILE_END_OF_PLATFORM_TILES:
                return (_y & $F8)+(background-gfx#TILE_START_OF_PLAT_TOP_TILES)
            gfx#TILE_SPACE:
                'empty space, we need to look below
                _y+=8                                        'empty space
            gfx#TILE_LEVEL_3_PLATFORM,gfx#TILE_LEVEL_4_PLATFORM,gfx#TILE_BOTTOM_OF_RIVET:
                'full platforms
                return (_y & $F8)-1
            gfx#TILE_END_LOWER_PLAT_LAD_TILES:
                'lower platform - lots of it
                return (_y & $F8)+(background-gfx#TILE_START_OF_LADDER_TILES)           'tile with ladder below
            gfx#TILE_END_OF_LOWER_PLAT_TILES:
                return (_y & $F8)+(background-gfx#TILE_START_OF_LADDER_TILES)           'platform with space below
            gfx#TILE_FULL_LADDER..gfx#TILE_END_LOWER_PLAT_LAD_TILES-1:
                'lower platform - not much
                _y+=8                                        'tile with ladder below
            gfx#TILE_START_OF_PLATFORM_TILES..gfx#TILE_END_OF_LOWER_PLAT_TILES:
                _y+=8                                        'platform with space below
            other:
                _y+=8

PRI LadderTopHeight(_x,_y) | background, current_y
    ' Calculates the position of the platform at the top of a ladder.  
    ' If we are by a ladder, then this one pixel above the platform at the top of the ladder,
    ' Otherwise it's the same value as PlatformHeight( ).
    ' If it's a broken ladder, then it's still the position of the platform above.
    current_y := PlatformHeight(_x,_y)
    repeat
        if current_y<0
            ' This must be one of Kong's ladders
            return _y
        background := TileAt(_x,current_y)
        case background
            gfx#TILE_FULL_LADDER..gfx#TILE_END_OF_LADDER_TILES,gfx#TILE_INVISIBLE_LADDER:
                current_y-=8                              'ladders + workaround invisible ladder
            'top of platform
            gfx#TILE_FULL_PLATFORM..gfx#TILE_END_OF_PLATFORM_TILES:
                return (current_y & $F8)+(background-gfx#TILE_START_OF_PLAT_TOP_TILES)
            'empty space
            gfx#TILE_SPACE:
                return current_y                          'empty space
            'full platforms
            gfx#TILE_LEVEL_3_PLATFORM,gfx#TILE_LEVEL_4_PLATFORM:
                current_y-=8
            'lower platform - lots of it
            gfx#TILE_END_OF_LOWER_PLAT_TILES:
                return (current_y & $F8)+(background-gfx#TILE_START_OF_LADDER_TILES) 'platform with space below
            'lower platform - not much
            gfx#TILE_START_OF_PLATFORM_TILES..constant(gfx#TILE_FULL_PLATFORM-2):
                return current_y                          'platform with space below
            other:
                return current_y

PRI LadderBottomHeight(_x,_y) | background
    ' Calculates the position of the platform at the bottom of a ladder.  
    ' If we are above a ladder, then this one pixel above the platform at the bottom of the ladder,
    ' Otherwise it's the same value as PlatformHeight( ).
    ' If it's a broken ladder, then that doesn't count.  It's still the position of the platform above.
    _y := PlatformHeight(_x,_y)
    background := TileAt(_x,_y+8)
    if (background==gfx#TILE_FULL_PLATFORM_LADDER_TILE or background==gfx#TILE_FULL_PLATFORM or background==gfx#TILE_LEVEL_3_PLATFORM or background==gfx#TILE_LEVEL_4_PLATFORM) and TileAt(_x,_y+16)<>gfx#TILE_SPACE
        _y+=8
    repeat
        background := TileAt(_x,_y+8)
        'debugdec(@tiletext,background)
        case background
            'empty space
            gfx#TILE_SPACE:
                return _y-8                                         ' empty space
            'full platforms
            gfx#TILE_LEVEL_3_PLATFORM,gfx#TILE_LEVEL_4_PLATFORM:
                return (_y & $F8)+7
            gfx#TILE_FULL_LADDER..gfx#TILE_END_OF_LADDER_TILES,gfx#TILE_INVISIBLE_LADDER:
                _y+=8                                               'ladders + workaround invisible ladder
            gfx#TILE_START_OF_PLATFORM_TILES..gfx#TILE_END_OF_LOWER_PLAT_TILES:
                return (_y & $F8)+(background-gfx#TILE_START_OF_PLATFORM_TILES)                  'platform with space below
            other:          return (_y & $F8)+7

PRI BarrelLadderBottomHeight(_x,_y) | background
    ' Calculates the position of the platform at the bottom of a ladder.  
    ' If we are above a ladder, then this one pixel above the platform at the bottom of the ladder,
    ' Otherwise it's the same value as LowPlatformHeight( ).
    ' If it's a broken ladder, then that doesn't count.  It's still the position of the platform above.
    ' This is a variation for barrels, which will include ladders with gaps. 
    'debugdec(string("YBEFORE"),_y)
    _y := PlatformHeight(_x,_y)
    'debugdec(string("YAFTER"),_y)
    background := TileAt(_x,_y+8)
    if (background==gfx#TILE_FULL_PLATFORM_LADDER_TILE or background==gfx#TILE_FULL_PLATFORM or background==gfx#TILE_LEVEL_3_PLATFORM or background==gfx#TILE_LEVEL_4_PLATFORM) and TileAt(_x,_y+16)<>gfx#TILE_SPACE
        _y+=8
        'debugdec(string("EXTRA"),0)
    repeat
        background := TileAt(_x,_y+8)
        'debugdec(@tiletext,background)
        case background
            'full platforms
            gfx#TILE_LEVEL_3_PLATFORM,gfx#TILE_LEVEL_4_PLATFORM,gfx#TILE_FULL_PLATFORM_LADDER_TILE,gfx#TILE_FULL_PLATFORM:
                return (_y & $F8)+7
            gfx#TILE_FULL_LADDER..gfx#TILE_END_OF_LADDER_TILES,gfx#TILE_INVISIBLE_LADDER:
                _y+=8                           'ladders + workaround invisible ladder
            gfx#TILE_START_OF_PLATFORM_TILES..gfx#TILE_END_OF_LOWER_PLAT_TILES:
                return (_y & $F8)+(background-gfx#TILE_START_OF_PLATFORM_TILES) 'platform with space below
            other:
                return (_y & $F8)+7

PRI SelectMap(map)
    rend_map := gfx.map_adr+constant(32*28*2)*map

PRI ClearMap(default_palette) | p, i
    p := gfx.map_adr
    repeat i from 0 to constant(28*32-1)
        word[p]:=gfx#TILE_SPACE + default_palette<<8
        p+=2

PRI DrawPlatformTile(x_in_tiles,y_in_pixels) | tilepos, y_in_tile
    tilepos:=(x_in_tiles+2+((y_in_pixels>>3)<<5))<<1 + gfx.map_adr
    y_in_tile:=y_in_pixels&$7
    if y_in_tile==0
            byte[tilepos]:=gfx#TILE_FULL_PLATFORM
    else
        if byte[tilepos]=>gfx#TILE_FULL_LADDER and byte[tilepos]=<gfx#TILE_END_OF_LADDER_TILES
            byte[tilepos]:=gfx#TILE_FULL_PLATFORM_LADDER_TILE+y_in_tile
        else
            byte[tilepos]:=gfx#TILE_FULL_PLATFORM+y_in_tile
        tilepos+=64
        if byte[tilepos]=>gfx#TILE_FULL_LADDER and byte[tilepos]=<gfx#TILE_END_OF_LADDER_TILES
            byte[tilepos]:=gfx#TILE_FULL_LADDER+y_in_tile
        else
            byte[tilepos]:=constant(gfx#TILE_START_OF_PLATFORM_TILES-1)+y_in_tile

PRI DrawString(x,y,text,palette) | pos, i
    pos := x+y*32
    repeat i from 0 to strsize(text)-1
        word[rend_map][pos++] := byte[text][i]-8 + palette<<8

PRI DrawNumber(x,y,number,digits,palette) | pos, i
    pos := x+y*32
    repeat i from 0 to digits-1
        word[rend_map][pos+(digits-1-i)] := number//10 + 40 + palette<<8
        number/=10            
         
PRI DrawKong(x,y) | char, palette, xx, yy, pos
    char := gfx#TILE_KONG_START
    palette := 5<<8
    repeat yy from y to y+3
        pos := x+yy*32
        repeat xx from x to x+5
            word[rend_map][pos++] := char++ +palette
        
PRI DrawKongHeight(x,y,h) | palette, pos
    palette := 5<<8                     
    pos := x+y*32
    word[rend_map][pos++] := lookupz(h:2,3,4,1) +palette
    word[rend_map][pos++] := lookupz(h:3,0,3,0) +palette
    word[rend_map][pos++] := lookupz(h:gfx#TILE_SPACE,gfx#TILE_SPACE,gfx#TILE_SPACE,0) +palette
    word[rend_map][pos] := gfx#TILE_SMALL_M +palette

PRI DrawStatus | i
    DrawString(0,0,string("HI SCORE"),1)
'    DrawString(0,1,string("000000"),4)
    DrawString(29,0,string("1UP"),1)
    AddToScore(0)
'    DrawString(26,1,string("000000"),4)
    repeat i from 0 to 2
        word[gfx.map_adr+40][i] := gfx#TILE_MARIO_LIFE+(3<<8)
    DrawString(20,2,string("L=01"),2)

PRI DrawBonusBox | pos
    pos:=gfx.map_adr+constant((3*32+26)*2)
    byte[pos]:=gfx#TILE_BONUS
    pos+=2
    byte[pos]:=gfx#TILE_BONUS+1
    pos+=2
    byte[pos]:=gfx#TILE_BONUS+2
    pos+=2
    byte[pos]:=gfx#TILE_BONUS+3
    pos+=2
    byte[pos]:=gfx#TILE_BONUS+4
    pos+=2
    byte[pos]:=gfx#TILE_BONUS+5
    pos+=54
    byte[pos]:=gfx#TILE_BONUS+6
    pos+=10
    byte[pos]:=gfx#TILE_BONUS+7
    pos+=54
    byte[pos]:=gfx#TILE_BONUS+8
    pos+=2
    byte[pos]:=gfx#TILE_BONUS+9
    pos+=2
    byte[pos]:=gfx#TILE_BONUS+9
    pos+=2
    byte[pos]:=gfx#TILE_BONUS+9
    pos+=2
    byte[pos]:=gfx#TILE_BONUS+9
    pos+=2
    byte[pos]:=gfx#TILE_BONUS+10
    SubFromTimer(0)
'    DrawString(27,4,string("0000"),4)
    
PRI SetKongSprites | dest, i, temp, end, block
    block := kong_pose_source 
    dest := @rend_sprites[kong_sprites]
    case game_state
        GAME_CLIMB_SCENE:
            '6 kong + pauline
            end := 6
        GAME_LEVEL_1,GAME_LEVEL_12_END_SCENE,GAME_LEVEL_123_FOLLOW_ON:
            '8 sprites in centre barrel pose
            end := 7
        other:
            'reusing 2 kong sprites on level 3 for ladders
            end := 5
    repeat i from 0 to end
        temp:=long[block]
        byte[@temp] += kong_real_y
        byte[@temp][1] += kong_real_x - $3c  
        long[dest]:=temp
        block+=4
        dest+=4

PRI AddToScore(delta)
    game_score+=delta
    DrawNumber(26,1,game_score,6,4)
                      
PRI SubFromTimer(delta)
    timer-=delta
    if timer>900
        DrawNumber(27,4,timer,4,0)
    else
        DrawNumber(27,4,timer,4,9)

PRI MarioCollision(sprite_num) | xd,yd
    if byte[@rend_sprites[sprite_num]][SPRITE_FLAGS]&SPRITE_INVISIBLE==0
        xd:=byte[@rend_sprites[sprite_num]][SPRITE_XPOS]-byte[@rend_sprites[MARIO_SPRITE]][SPRITE_XPOS]
        'xd is negative if sprite is to the right of Mario
        if xd>-10 and xd<10
            yd:=byte[@rend_sprites[sprite_num]][SPRITE_YPOS]-byte[@rend_sprites[MARIO_SPRITE]][SPRITE_YPOS]
            'yd is negative if sprite is above Mario
            if yd>-13 and yd<9
                return TRUE
    return FALSE

PRI HammerCollision(sprite_num) | xd,yd
    if action_hammer
        if byte[@rend_sprites[sprite_num]][SPRITE_FLAGS]&SPRITE_INVISIBLE==0
            xd:=byte[@rend_sprites[sprite_num]][SPRITE_XPOS]-byte[@rend_sprites[action_hammer]][SPRITE_XPOS]
            'xd is negative if sprite is to the right of Hammer
            if xd>-9 and xd<9
                yd:=byte[@rend_sprites[sprite_num]][SPRITE_YPOS]-byte[@rend_sprites[action_hammer]][SPRITE_YPOS]
                'yd is negative if sprite is above Hammer
                if yd>-7 and yd<12
                    return TRUE
    return FALSE

CON
' //////////////////////////////////////////////////////////////////
' NES Game Paddle Read
' //////////////////////////////////////////////////////////////////       
' reads both gamepads in parallel encodes 8-bits for each in format
' right game pad #1 [15..8] : left game pad #0 [7..0]

    GP_RIGHT  = %00000001
    GP_LEFT   = %00000010
    GP_DOWN   = %00000100
    GP_UP     = %00001000
    GP_START  = %00010000
    GP_SELECT = %00100000
    GP_B      = %01000000
    GP_A      = %10000000

PUB NES_Read_Gamepad : nes_bits        |  i

' set I/O ports to proper direction
' P3 = JOY_CLK      (4)
' P4 = JOY_SH/LDn   (5) 
' P5 = JOY_DATAOUT0 (6)
' P6 = JOY_DATAOUT1 (7)
' NES Bit Encoding

' step 1: set I/Os
DIRA [3] := 1 ' output
DIRA [4] := 1 ' output
DIRA [5] := 0 ' input
DIRA [6] := 0 ' input

' step 2: set clock and latch to 0
OUTA [3] := 0 ' JOY_CLK = 0
OUTA [4] := 0 ' JOY_SH/LDn = 0
'Delay(1)

' step 3: set latch to 1
OUTA [4] := 1 ' JOY_SH/LDn = 1
'Delay(1)

' step 4: set latch to 0
OUTA [4] := 0 ' JOY_SH/LDn = 0

' step 5: read first bit of each game pad

' data is now ready to shift out
' first bit is ready 
nes_bits := 0

' left controller
nes_bits := INA[5] | (INA[6] << 8)

' step 7: read next 7 bits
repeat i from 0 to 6
 OUTA [3] := 1 ' JOY_CLK = 1
 'Delay(1)             
 OUTA [3] := 0 ' JOY_CLK = 0
 nes_bits := (nes_bits << 1)
 nes_bits := nes_bits | INA[5] | (INA[6] << 8)

 'Delay(1)             
' invert bits to make positive logic
nes_bits := (!nes_bits & $FFFF)

' //////////////////////////////////////////////////////////////////
' End NES Game Paddle Read
' //////////////////////////////////////////////////////////////////  

VAR
  long  row
  long  col

PUB DebugInit(map)
    wordfill(map,gfx#TILE_SPACE,32*28)
    DebugReset

PUB DebugReset
  row := 10
  col := 0

{PUB DebugHex(title,number) | i, digit
    i:=0
    repeat while byte[title][i]<>0
        debug_map[row*32+col++] := byte[title][i]
        i++
    debug_map[row*32+col++] := 58
    digit := (number >> 28)
    debug_map[row*32+col++] := digit+48-(digit>9)*7
    digit := ((number >> 24) & $F)
    debug_map[row*32+col++] := digit+48-(digit>9)*7
    digit := ((number >> 20) & $F)
    debug_map[row*32+col++] := digit+48-(digit>9)*7
    digit := ((number >> 16) & $F)
    debug_map[row*32+col++] := digit+48-(digit>9)*7
    digit := ((number >> 12) & $F)
    debug_map[row*32+col++] := digit+48-(digit>9)*7
    digit := ((number >> 8) & $F)
    debug_map[row*32+col++] := digit+48-(digit>9)*7
    digit := ((number >> 4) & $F)
    debug_map[row*32+col++] := digit+48-(digit>9)*7
    digit := (number & $F)
    debug_map[row*32+col++] := digit+48-(digit>9)*7 
    col:=0
    row+=1
    row<#=27
}
PUB DebugDec(title,number) | i
    i:=0
    repeat while byte[title][i]<>0
        debug_map[row*32+col++] := byte[title][i]-8
        i++
    debug_map[row*32+col++] := 58-8
    debug_map[row*32+col+9] := number//10 + 40
    number/=10   
    debug_map[row*32+col+8] := number//10 + 40
    number/=10   
    debug_map[row*32+col+7] := number//10 + 40
    number/=10   
    debug_map[row*32+col+6] := number//10 + 40
    number/=10   
    debug_map[row*32+col+5] := number//10 + 40
    number/=10   
    debug_map[row*32+col+4] := number//10 + 40
    number/=10   
    debug_map[row*32+col+3] := number//10 + 40
    number/=10            
    debug_map[row*32+col+2] := number//10 + 40
    number/=10   
    debug_map[row*32+col+1] := number//10 + 40
    number/=10   
    debug_map[row*32+col+0] := number//10 + 40
    col:=0
    row++
    row<#=27
  
DAT
'For some reason the first DAT long is corrupted even before Main is run. 
                        long    0
'Used for Kong doing barrel rolling
kong_center_barrel_template
                        long    $00_22_3c_00            'torso
                        long    $01_20_3c_00            'head
                        long    $00_24_48_00            'right leg
                        long    $01_24_30_00            'left leg
                        long    $01_28_2c_00            'left arm
                        long    $00_28_4c_00            'right arm
                        long    $01_27_2c_00            'left shoulder
                        long    $00_27_4c_00            'right shoulder
kong_center_sad_template
                        long    $00_22_3c_00            'torso
                        long    $01_20_3c_00            'head
                        long    $00_24_48_00            'right leg
                        long    $01_24_30_00            'left leg
                        long    $00_26_31_00            'left arm
                        long    $01_26_47_00            'right arm
                        long    $04_00_00_00            'empty
                        long    $04_00_00_00            'empty
kong_left_template
                        long    $00_2b_3a_00            'torso
                        long    $00_2d_2a_00            'head
                        long    $00_29_4a_00            'right leg
                        long    $00_2a_2a_00            'left leg
                        long    $00_2c_3a_00            'shoulder
                        long    $04_00_00_00            'empty
                        long    $04_00_00_00            'empty
                        long    $04_00_00_00            'empty
kong_right_template
                        long    $01_2b_3c_00            'torso
                        long    $01_2d_4c_00            'head
                        long    $01_29_2c_00            'right leg
                        long    $01_2a_4c_00            'left leg
                        long    $01_2c_3c_00            'shoulder
                        long    $04_00_00_00            'empty
                        long    $04_00_00_00            'empty
                        long    $04_00_00_00            'empty

' Used for normal kong state Levels 2-4
kong_center_roar_r_template
                        long    $00_22_3c_00            'torso
                        long    $01_21_3c_00            'head
                        long    $00_24_48_00            'right leg
                        long    $00_23_30_00            'left leg
                        long    $00_26_31_00            'left arm
                        long    $00_25_4c_00            'right arm
                        long    $04_00_00_00            'empty
                        long    $04_00_00_00            'empty
kong_center_roar_l_template
                        long    $00_22_3c_00            'torso
                        long    $01_21_3c_00            'head
                        long    $01_23_48_00            'right leg
                        long    $01_24_30_00            'left leg
                        long    $01_25_2c_00            'left arm
                        long    $01_26_47_00            'right arm
                        long    $04_00_00_00            'empty
                        long    $04_00_00_00            'empty
' Back of Kong. Used for climbing
kong_back_right
                        long    $00_33_34_00            'left leg
                        long    $00_34_44_00            'right leg
                        long    $00_2f_34_00            'left shoulder
                        long    $00_30_44_00            'right shoulder
                        long    $00_31_31_00            'left arm
                        long    $00_32_4a_00            'right arm
                        long    $04_00_00_00            'empty
                        long    $04_00_00_00            'empty
kong_back_left
                        long    $01_34_34_00            'left leg
                        long    $01_33_44_00            'right leg
                        long    $00_2f_34_00            'left shoulder
                        long    $00_30_44_00            'right shoulder
                        long    $01_32_32_00            'left arm
                        long    $00_31_4a_00            'right arm
                        long    $04_00_00_00            'empty
                        long    $04_00_00_00            'empty
kong_back_right_with_pauline
                        long    $00_33_34_00            'left leg
                        long    $00_34_44_00            'right leg
                        long    $00_2f_34_00            'left shoulder
                        long    $00_30_44_00            'right shoulder
                        long    $00_31_31_00            'left arm
                        long    $00_2e_4a_00            'right arm
                        long    $00_13_4b_00            'pauline
                        long    $04_00_00_00            'empty
kong_back_left_with_pauline
                        long    $01_34_34_00            'left leg
                        long    $01_33_44_00            'right leg
                        long    $00_2f_34_00            'left shoulder
                        long    $00_30_44_00            'right shoulder
                        long    $01_32_32_00            'left arm
                        long    $00_2e_4a_00            'right arm
                        long    $00_13_4b_00            'pauline
                        long    $04_00_00_00            'empty
' Kong falling
kong_upsidedown_1
                        long    $02_22_3c_10            'torso
                        long    $02_21_3c_30            'head
                        long    $02_24_48_10            'right leg
                        long    $03_24_30_10            'left leg
                        long    $02_26_31_28            'left arm
                        long    $03_26_47_28            'right arm
                        long    $04_00_00_00            'empty
                        long    $04_00_00_00            'empty
kong_upsidedown_2
                        long    $02_22_3c_10            'torso
                        long    $02_1d_3c_30            'head
                        long    $02_24_48_10            'right leg
                        long    $03_24_30_10            'left leg
                        long    $02_26_31_28            'left arm
                        long    $03_26_47_28            'right arm
                        long    $04_00_00_00            'empty
                        long    $04_00_00_00            'empty
kong_upsidedown_3
                        long    $02_22_3c_10            'torso
                        long    $02_1e_3c_30            'head
                        long    $02_24_48_10            'right leg
                        long    $03_24_30_10            'left leg
                        long    $02_26_31_28            'left arm
                        long    $03_26_47_28            'right arm
                        long    $04_00_00_00            'empty
                        long    $04_00_00_00            'empty
kong_upsidedown_4
                        long    $02_22_3c_10            'torso
                        long    $02_1f_3c_30            'head
                        long    $02_24_48_10            'right leg
                        long    $03_24_30_10            'left leg
                        long    $02_26_31_28            'left arm
                        long    $03_26_47_28            'right arm
                        long    $04_00_00_00            'empty
                        long    $04_00_00_00            'empty
kong_invisible
                        long    $04_00_00_00            'empty
                        long    $04_00_00_00            'empty
                        long    $04_00_00_00            'empty
                        long    $04_00_00_00            'empty
                        long    $04_00_00_00            'empty
                        long    $04_00_00_00            'empty
                        long    $04_00_00_00            'empty
                        long    $04_00_00_00            'empty
                        
DAT
level1def     byte      DRAW_USE_TILE,gfx#TILE_FULL_LADDER
              byte      DRAW_VERTICALS
              'Kong's ladders
              
              byte      8,0,6
              byte      10,0,6
              byte      16,4,6
              'Other ladders
              byte      23,7,9
              byte      11,7,7
              byte      11,9,10
              byte      4,11,13
              byte      9,11,14
              byte      21,11,11
              byte      21,14,14
              byte      23,16,18
              byte      14,15,18
              byte      8,15,15
              byte      8,18,19
              byte      4,20,22
              byte      12,19,22
              byte      23,24,26
              byte      10,23,23
              byte      10,26,26
              byte      DRAW_USE_TILE,gfx#TILE_INVISIBLE_LADDER
              byte      DRAW_VERTICALS
              byte      21,13,13
              byte      8,17,17
              byte      10,25,25
              'Pauline's platform
              byte      DRAW_PLATFORM_FLAT,11,16,$18
              'Kong's platform
              byte      DRAW_PLATFORM_FLAT,0,17,$34
              byte      DRAW_PLATFORM_DOWNWARDS,18,25,$35
             'Platforms in between
              byte      DRAW_PLATFORM_UPWARDS,2,27,$59     
              byte      DRAW_PLATFORM_DOWNWARDS,0,25,$6e     
              byte      DRAW_PLATFORM_UPWARDS,2,27,$9b     
              byte      DRAW_PLATFORM_DOWNWARDS,0,25,$b0
              'Mario's plaform
              byte      DRAW_PLATFORM_FLAT,0,13,$d8
              byte      DRAW_PLATFORM_UPWARDS,14,27,$d7
              byte      DRAW_END_DRAWING

DAT
level2def
              'platforms
              byte      DRAW_USE_TILE,gfx#TILE_FULL_PLATFORM
              byte      DRAW_HORIZONTALS
              byte      0,27,27
              byte      0,2,25
              byte      0,2,20
              byte      0,2,13
              byte      7,10,13
              byte      8,10,22
              byte      15,17,25
              byte      19,20,24
              byte      22,23,23
              byte      25,27,22
              byte      26,27,19
              byte      23,24,18
              byte      20,21,17
              byte      17,18,16
              byte      23,27,14
              byte      16,18,12
              byte      20,21,11
              byte      23,24,10
              byte      26,27,9
              byte      0,20,7
              byte      0,20,7
              byte      11,16,3
              'Ladders
              byte      DRAW_USE_TILE,gfx#TILE_FULL_LADDER
              byte      DRAW_VERTICALS
              byte      8,0,6
              byte      10,0,6
              byte      16,4,6
              byte      20,8,10
              byte      26,10,13
              byte      17,13,15
              byte      23,15,17
              byte      26,20,21
              byte      1,21,24
              byte      2,14,19
              byte      8,14,21
              byte      10,14,21
              'Poles
              byte      DRAW_USE_TILE,gfx#TILE_POLE
              byte      DRAW_VERTICALS
              byte      4,9,25
              byte      12,9,25
              byte      DRAW_USE_TILE,gfx#TILE_POLE+1
              byte      DRAW_VERTICALS
              byte      5,9,25
              byte      13,9,25
              byte      DRAW_END_DRAWING
DAT
level3def
              'platforms
              byte      DRAW_USE_TILE,gfx#TILE_FULL_PLATFORM
              byte      DRAW_HORIZONTALS
              byte      11,16,3
              byte      1,5,17
              byte      8,18,17
              byte      21,26,17
              byte      0,27,27
              byte      DRAW_USE_TILE,gfx#TILE_LEVEL_3_PLATFORM
              byte      DRAW_HORIZONTALS
              byte      1,26,7
              byte      0,11,12
              byte      16,27,12
              byte      1,26,22
              'kong ladders
              byte      DRAW_USE_TILE,gfx#TILE_FULL_LADDER
              byte      DRAW_VERTICALS
              byte      8,0,6
              byte      10,0,6
              byte      16,4,6
              'other ladders
              byte      2,10,11
              byte      25,10,11
              byte      10,13,16
              byte      17,13,16
              byte      8,18,21
              byte      18,18,21
              byte      3,23,26
              byte      10,23,26
              byte      17,23,26
              byte      24,23,26
              byte      3,13,16
              byte      24,13,16
              'trellis
              'byte      DRAW_USE_TILE,gfx#TILE_TRELLIS
              byte      DRAW_RECTANGLE,12,14,15,16,gfx#TILE_TRELLIS
              'byte      12,15,14
              'byte      12,15,15
              'byte      12,15,16
              byte      DRAW_END_DRAWING                    

DAT
level4def
    'platforms
              byte      DRAW_USE_TILE,gfx#TILE_LEVEL_4_PLATFORM
              byte      DRAW_HORIZONTALS
              byte      0,27,27
              byte      1,26,22
              byte      2,25,17
              byte      3,24,12
              byte      4,23,7
              byte      7,20,3
    'ladders
              byte      DRAW_USE_TILE,gfx#TILE_FULL_LADDER
              byte      DRAW_VERTICALS
              byte      1,23,26
              byte      13,23,26
              byte      26,23,26
              byte      2,18,21
              byte      9,18,21
              byte      18,18,21
              byte      25,18,21
              byte      3,13,16
              byte      13,13,16
              byte      24,13,16
              byte      4,8,11
              byte      8,8,11
              byte      19,8,11
              byte      23,8,11
    'poles
              byte      DRAW_USE_TILE,gfx#TILE_POLE
              byte      DRAW_VERTICALS
              byte      8,4,6
              byte      18,4,6
              byte      DRAW_USE_TILE,gfx#TILE_POLE+1
              byte      DRAW_VERTICALS
              byte      9,4,6
              byte      19,4,6
    'rivets
              byte      DRAW_USE_TILE,gfx#TILE_BOTTOM_OF_RIVET
              byte      DRAW_VERTICALS
              byte      7,7,7
              byte      20,7,7
              byte      7,12,12
              byte      20,12,12
              byte      7,17,17
              byte      20,17,17
              byte      7,22,22
              byte      20,22,22
              byte      DRAW_USE_TILE,gfx#TILE_TOP_OF_RIVET
              byte      DRAW_VERTICALS
              byte      7,6,6
              byte      20,6,6
              byte      7,11,11
              byte      20,11,11
              byte      7,16,16
              byte      20,16,16
              byte      7,21,21
              byte      20,21,21
              byte      DRAW_END_DRAWING
             
DAT
climbdef0
              byte      DRAW_USE_TILE,gfx#TILE_FULL_LADDER
              byte      DRAW_VERTICALS
              byte      8,0,6
              byte      10,0,6
              byte      16,4,7
              byte      14,7,7
              'Pauline's platform
              byte      DRAW_PLATFORM_FLAT,11,16,$18
              'Kong's platform
              byte      DRAW_PLATFORM_FLAT,0,25,$34
              'Platforms in between
              byte      DRAW_PLATFORM_FLAT,2,27,$4d     
              byte      DRAW_PLATFORM_FLAT,0,25,$6e     
              byte      DRAW_PLATFORM_FLAT,2,27,$8f     
              byte      DRAW_PLATFORM_FLAT,0,25,$b0
              'Mario's plaform
              byte      DRAW_PLATFORM_FLAT,0,27,$d0
                'long ladders
              byte      DRAW_VERTICALS
              byte      16,8,25
              byte      14,8,25
              byte      DRAW_END_DRAWING

climbdef72a   byte      DRAW_PLATFORM_FLAT,14,16,$6e
              byte      DRAW_END_DRAWING

climbdef72b   byte      DRAW_PLATFORM_FLAT,14,16,$8f
              byte      DRAW_END_DRAWING     

climbdef72c   byte      DRAW_PLATFORM_FLAT,14,16,$b0
              byte      DRAW_END_DRAWING

climbdef72d   byte      DRAW_PLATFORM_FLAT,14,16,$d0,DRAW_END_DRAWING

climbdef72e   byte      DRAW_USE_TILE,gfx#TILE_SPACE
              byte      DRAW_HORIZONTALS
              byte      14,16
climbdef72remove byte   0
              byte      DRAW_END_DRAWING              

climbdef390   byte      DRAW_USE_TILE,gfx#TILE_SPACE
              byte      DRAW_VERTICALS
              byte      16,7,12
              byte      14,7,12
              byte      DRAW_PLATFORM_FLAT,14,16,$4d
              byte      DRAW_PLATFORM_FLAT,14,16,$34
              byte      DRAW_HORIZONTALS
              byte      24,25,6
              byte      DRAW_PLATFORM_DOWNWARDS,18,25,$35
              byte      DRAW_END_DRAWING

climbdef456   byte      DRAW_USE_TILE,gfx#TILE_SPACE
              byte      DRAW_HORIZONTALS
              byte      2,21,9
              byte      2,5,10
              byte      DRAW_PLATFORM_UPWARDS,2,27,$59
              byte      DRAW_END_DRAWING

climbdef490   byte      DRAW_USE_TILE,gfx#TILE_SPACE
              byte      DRAW_HORIZONTALS
              byte      4,25,13
              byte      20,25,14
              byte      DRAW_PLATFORM_DOWNWARDS,0,25,$6e     
              byte      DRAW_END_DRAWING

climbdef524   byte      DRAW_USE_TILE,gfx#TILE_SPACE
              byte      DRAW_HORIZONTALS
              byte      2,25,17
              byte      2,10,18
              byte      DRAW_PLATFORM_UPWARDS,2,27,$9b     
              byte      DRAW_END_DRAWING

climbdef558   byte      DRAW_USE_TILE,gfx#TILE_SPACE
              byte      DRAW_HORIZONTALS
              byte      16,25,22
              byte      DRAW_PLATFORM_DOWNWARDS,0,25,$b0     
              byte      DRAW_END_DRAWING

climbdef592   byte      DRAW_USE_TILE,gfx#TILE_SPACE
              byte      DRAW_HORIZONTALS
              byte      0,13,26
              byte      DRAW_PLATFORM_FLAT,0,13,$d8
              byte      DRAW_PLATFORM_UPWARDS,14,27,$d7
              byte      DRAW_END_DRAWING

DAT
level4end1    byte      DRAW_RECTANGLE,8,7,19,22,gfx#TILE_SPACE
              byte      DRAW_RECTANGLE,8,23,19,26,gfx#TILE_LEVEL_4_PLATFORM
              byte      DRAW_END_DRAWING

level4end2    byte      DRAW_RECTANGLE,7,3,20,6,gfx#TILE_SPACE
              byte      DRAW_USE_TILE,gfx#TILE_LEVEL_4_PLATFORM
              byte      DRAW_HORIZONTALS
              byte      7,20,7
              byte      DRAW_END_DRAWING

DAT
' There seems to be some pointer leakage here.  Extra long as a patch.
                        long    0
' Hub scanline buffer = 256 pixels, 8 bits per pixel = 2048 bits = 256 bytes = 64 longs
hub_scanline_buffer
colorbar0               long    $0b_0b_0b_0b
colorbar1               long    $0c_0c_0c_0c
colorbar2               long    $0d_0d_0d_0d
colorbar3               long    $0e_0e_0e_0e
colorbar4               long    $1b_0b_1b_1b
colorbar5               long    $1c_0c_1c_1c
colorbar6               long    $1d_0d_1d_1d
colorbar7               long    $1e_0e_1e_1e
colorbar8               long    $2b_0b_2b_2b
colorbar9               long    $2c_2c_2c_2c
colorbar10              long    $2d_2d_2d_2d
colorbar11              long    $2e_2e_2e_2e
colorbar12              long    $3b_3b_3b_3b
colorbar13              long    $3c_3c_3c_3c
colorbar14              long    $3d_3d_3d_3d
colorbar15              long    $3e_3e_3e_3e
colorbar16              long    $4b_4b_4b_4b
colorbar17              long    $4c_4c_4c_4c
colorbar18              long    $4d_4d_4d_4d
colorbar19              long    $4e_4e_4e_4e
colorbar20              long    $5b_5b_5b_5b
colorbar21              long    $5c_5c_5c_5c
colorbar22              long    $5d_5d_5d_5d
colorbar23              long    $5e_5e_5e_5e
colorbar24              long    $6b_6b_6b_6b
colorbar25              long    $6c_6c_6c_6c
colorbar26              long    $6d_6d_6d_6d
colorbar27              long    $6e_6e_6e_6e
colorbar28              long    $7b_7b_7b_7b
colorbar29              long    $7c_7c_7c_7c
colorbar30              long    $7d_7d_7d_7d
colorbar31              long    $7e_7e_7e_7e
colorbar32              long    $8b_8b_8b_8b
colorbar33              long    $8c_8c_8c_8c
colorbar34              long    $8d_8d_8d_8d
colorbar35              long    $8e_8e_8e_8e
colorbar36              long    $9b_9b_9b_9b
colorbar37              long    $9c_9c_9c_9c
colorbar38              long    $9d_9d_9d_9d
colorbar39              long    $9e_9e_9e_9e
colorbar40              long    $ab_ab_ab_ab
colorbar41              long    $ac_ac_ac_ac
colorbar42              long    $ad_ad_ad_ad
colorbar43              long    $ae_ae_ae_ae
colorbar44              long    $bb_bb_bb_bb
colorbar45              long    $bc_bc_bc_bc
colorbar46              long    $bd_bd_bd_bd
colorbar47              long    $be_be_be_be
colorbar48              long    $cb_cb_cb_cb
colorbar49              long    $cc_cc_cc_cc
colorbar50              long    $cd_cd_cd_cd
colorbar51              long    $ce_ce_ce_ce
colorbar52              long    $db_db_db_db
colorbar53              long    $dc_dc_dc_dc
colorbar54              long    $dd_dd_dd_dd
colorbar55              long    $de_de_de_de
colorbar56              long    $eb_eb_eb_eb
colorbar57              long    $ec_ec_ec_ec
colorbar58              long    $ed_ed_ed_ed
colorbar59              long    $ee_ee_ee_ee
colorbar60              long    $fb_fb_fb_fb
colorbar61              long    $fc_fc_fc_fc
colorbar62              long    $fd_fd_fd_fd
colorbar63              long    $fe_fe_fe_fe
' End of scanline buffer

scanline_req            long    0


_SONG_start
        byte    $03, $EF, $AD, $79, $35          'Instrument 0
        byte    $02, $EF, $AD, $79, $35          'Instrument 1
        byte    $02, $EF, $AD, $79, $35          'Instrument 2
        byte    $02, $EF, $AD, $79, $35          'Instrument 3
        byte    $02, $EF, $AD, $79, $35          'Instrument 4
        byte    $02, $EF, $AD, $79, $35          'Instrument 5
        byte    $02, $EF, $AD, $79, $35          'Instrument 6
        byte    $02, $EF, $AD, $79, $35          'Instrument 7
        byte    $FF                              'End of Instrument list
        byte    $63, $00, $83, $09, $63
        byte    $5C, $20, $93, $0C, $24
        byte    $1E, $40, $9C, $08, $49
        byte    $40, $60, $83, $08, $52
        byte    $36, $80, $F7, $08, $0C
        byte    $09, $A1, $06, $0A, $0F
        byte    $05, $00, $F7, $0B, $80, $87
        byte    $07, $20, $F7, $0A, $0D
        byte    $0B, $41, $06, $0A, $0D
        byte    $0B, $80, $F7, $09, $0C
        byte    $0B, $A1, $06, $0A, $0B
        byte    $0B, $60, $F7, $08, $0B
        byte    $0B, $21, $06, $09, $0D
        byte    $0B, $40, $F7, $09, $0E
        byte    $0B, $81, $06, $0A, $0E
        byte    $0B, $A0, $F7, $0A, $0E
        byte    $0B, $61, $06, $0A, $0D
        byte    $0B, $20, $F7, $0A, $0F
        byte    $0B, $41, $06, $0B, $6B
        byte    $0B, $81, $06, $0A, $80, $B2
        byte    $ff

_SONG_hammer
        byte    $03, $F8, $48, $22, $11          'Instrument 0
        byte    $02, $EF, $AD, $79, $35          'Instrument 1
        byte    $02, $EF, $AD, $79, $35          'Instrument 2
        byte    $02, $EF, $AD, $79, $35          'Instrument 3
        byte    $02, $EF, $AD, $79, $35          'Instrument 4
        byte    $02, $EF, $AD, $79, $35          'Instrument 5
        byte    $02, $EF, $AD, $79, $35          'Instrument 6
        byte    $02, $EF, $AD, $79, $35          'Instrument 7
        byte    $FF                              'End of Instrument list
        byte    $00, $01, $5D, $0B, $0F
        byte    $10, $21, $5D, $0B, $07
        byte    $08, $41, $5D, $0B, $07
        byte    $08, $61, $5D, $0B, $0F
        byte    $10, $81, $5D, $0B, $0F
        byte    $10, $A1, $B8, $0B, $0F
        byte    $10, $01, $5D, $0B, $0F
        byte    $10, $21, $B8, $0B, $0F
        byte    $10, $41, $5D, $0B, $0F
        byte    $10, $61, $B8, $0B, $0F
        byte    $10, $81, $B8, $0B, $07
        byte    $08, $A1, $B8, $0B, $07
        byte    $08, $01, $B8, $0B, $0F
        byte    $10, $21, $B8, $0B, $0F
        byte    $10, $42, $0B, $0B, $0F
        byte    $10, $61, $B8, $0B, $0F
        byte    $10, $82, $0B, $0B, $0F
        byte    $10, $A1, $B8, $0B, $0F
        byte    $10, $00, $01, $01, $01
        byte    $ff

                  
_SONG_background_music
        byte    $03, $EF, $AD, $79, $35          'Instrument 0
        byte    $02, $EF, $AD, $79, $35          'Instrument 1
        byte    $02, $EF, $AD, $79, $35          'Instrument 2
        byte    $02, $EF, $AD, $79, $35          'Instrument 3
        byte    $02, $EF, $AD, $79, $35          'Instrument 4
        byte    $02, $EF, $AD, $79, $35          'Instrument 5
        byte    $02, $EF, $AD, $79, $35          'Instrument 6
        byte    $02, $EF, $AD, $79, $35          'Instrument 7
        byte    $FF                              'End of Instrument list
        byte    $00, $00, $83, $08, $14
        byte    $3C, $20, $A5, $08, $14
        byte    $28, $40, $C4, $08, $14
        byte    $14, $60, $DC, $08, $14
        byte    $14, $80, $C4, $08, $14
        byte    $11, $80, $01, $01, $01
        byte    $ff

_SONG_how_high
        byte    $03, $EF, $AD, $79, $35          'Instrument 0
        byte    $02, $EF, $AD, $79, $35          'Instrument 1
        byte    $02, $EF, $AD, $79, $35          'Instrument 2
        byte    $02, $EF, $AD, $79, $35          'Instrument 3
        byte    $02, $EF, $AD, $79, $35          'Instrument 4
        byte    $02, $EF, $AD, $79, $35          'Instrument 5
        byte    $02, $EF, $AD, $79, $35          'Instrument 6
        byte    $02, $EF, $AD, $79, $35          'Instrument 7
        byte    $FF                              'End of Instrument list
        byte    $00, $01, $06, $06, $20
        byte    $25, $21, $4A, $08, $0F
        byte    $18, $41, $88, $09, $21
        byte    $23, $61, $4A, $08, $0E
        byte    $17, $81, $26, $08, $0D
        byte    $15, $A1, $4A, $08, $0D
        byte    $15, $01, $06, $09, $62
        byte    $18, $21, $06, $09, $14
        byte    $12, $41, $26, $09, $08
        byte    $07, $61, $4A, $09, $06
        byte    $05, $81, $5D, $0A, $06
        byte    $04, $A1, $88, $0A, $08
        byte    $06, $21, $B8, $09, $07
        byte    $06, $41, $EE, $09, $09
        byte    $09, $62, $0B, $06, $2D
        byte    $ff
        
' =/=/=/=/=/=/=/=/=/=/=/=/=/=/=/=/=/=/=/=/=/=/=/=/=/=/=/=/=/=/=/=/=/=/=/=/=/=/=/=/=/=/=/=/
' =/=/=/=/=/=/=/=/=/=/=/=/=/=/=/=/ HDMF LITE, (START)    /=/=/=/=/=/=/=/=/=/=/=/=/=/=/=/=/
' =/=/=/=/=/=/=/=/=/=/=/=/=/=/=/=/=/=/=/=/=/=/=/=/=/=/=/=/=/=/=/=/=/=/=/=/=/=/=/=/=/=/=/=/
CON 
  HDMF_TIMEBASE_TICK     = 80_000_000 / 100         ' HDMF uses a 10 mesc tick (100 ticks per second).
                                                    ' HDMF_TICK is expressed in system clock ticks
                                                    '     so at 80MHz is 80,000,000 / 100
                                                       
  HDMF_DURATION_TICK     = sfx#SAMPLE_RATE / 100    ' HDMF duration is also 100 ticks per second
                                                    ' DURATION_TICK is expressed in sound driver sample
                                                    '     rate ticks so is SAMPLE_RATE / 100
                                                       
  'Player states   
  HDMF__STATE_IDLE        = %00000000  
  HDMF__STATE_START_SONG  = %00000001
  HDMF__STATE_PLAY_FETCH  = %00000100
  HDMF__STATE_PLAY_WAIT   = %00000101
  HDMF__CHECK_IS_PLAYING  = %00000100

  'Player flags
  HDMF__FLAG_LAST_NOTE_5_BYTES = %00000001
  HDMF__FLAG_LOOP_SONG         = %00000010
  HDMF__FLAG_FIRST_NOTE        = %00000100

  HDMF_MAX_INSTRUMENTS    = 8
  HDMF_BYTES_PER_NOTE_MAX = 6


OBJ

  'snd    : "NS_sound_drv_052_22khz_16bit.spin"   'Sound driver

VAR

  long hdmf1_state
  long hdmf1_i
  long hdmf1_song_ptr
  long hdmf1_song_start_ptr
  byte hdmf1_flags
  long hdmf1_current_note_time
  long hdmf1_note_delta_time
  byte hdmf1_note_data[HDMF_BYTES_PER_NOTE_MAX]
  byte hdmf1_instrument_wave[HDMF_MAX_INSTRUMENTS]
  long hdmf1_instrument_envelope[HDMF_MAX_INSTRUMENTS]

  long hdmf1_P_freq                                  
  long hdmf1_P_duration
  long hdmf1_P_channel
  long hdmf1_P_volume
  long hdmf1_P_time
  long hdmf1_P_instrument
  
' =/=/=/=/=/=/=/=/=/=/=/=/=/=/=/=/=/=/=/=/=/=/=/=/=/=/=/=/=/=/=/=/=/=/=/=/=/=/=/=/=/=/=/=/
' =/=/=/=/=/=/=/=/=/=/=/=/=/=/=/=/ HDMF LITE, (END)      /=/=/=/=/=/=/=/=/=/=/=/=/=/=/=/=/
' =/=/=/=/=/=/=/=/=/=/=/=/=/=/=/=/=/=/=/=/=/=/=/=/=/=/=/=/=/=/=/=/=/=/=/=/=/=/=/=/=/=/=/=/   
 